diff --git a/include/gpac/internal/m3u8.h b/include/gpac/internal/m3u8.h
index 043fa3b13a..92302ec8d7 100644
--- a/include/gpac/internal/m3u8.h
+++ b/include/gpac/internal/m3u8.h
@@ -1,8 +1,8 @@
 /**
  *			GPAC - Multimedia Framework C SDK
  *
- *					Authors: Pierre Souchay - Jean Le Feuvre
- *			Copyright (c) Telecom ParisTech 2010-2012
+ *					Authors: Pierre Souchay - Jean Le Feuvre - Romain Bouqueau
+ *			Copyright (c) Telecom ParisTech 2010-2012, Romain Bouqueau
  *					All rights reserved
  *
  *  This file is part of GPAC
@@ -24,150 +24,70 @@
  */
 #ifndef M3U8_PLAYLIST_H
 #define M3U8_PLAYLIST_H
+
 #include <gpac/tools.h>
 #include <gpac/list.h>
 
-/**
- * Global Structure
- *
- * For a stream with multiple bandwidths and multiple programs
- *
- * VariantPlayList
- *  |
- *  |_ program id 1
- *  |     |
- *  |     |_ bandwidth X : playlistElement1
- *  |     |- bandwidth Y : playlistElement2
- *  |
- *  |- program id 2
- *        |
- *        |_ bandwidth Z : playlistElement
- *
- * For a "normal" playlist
- *
- * VariantPlayList
- *  |
- *  |_ program id 1
- *        |
- *        |_ bandwidth 0 : playlistElement1
- *
- * Where PlaylistElement can be :
- *  - a stream (real resource)
- *  - a playlist (list of PlaylistElements itself)
- */
 
-#define M3U8_UNKOWN_MIME_TYPE "unknown"
+#define M3U8_UNKNOWN_MIME_TYPE "unknown"
 
 /**
- * Basic Stream structure
+ * Basic Media structure
  */
-typedef struct s_stream {
-	u8 i;
-} Stream;
+typedef struct s_media {
+	int i; //unused: C requires that a struct or union has at least one member
+} Media;
 
 /**
  * The playlist contains a list of elements to play
  */
-typedef struct s_playList {
-	int currentMediaSequence;
+struct s_playList {
+	int current_media_seq;
 	int target_duration;
-	int mediaSequenceMin;
-	int mediaSequenceMax;
+	int media_seq_min;
+	int media_seq_max;
 	int computed_duration;
-	char is_ended;
-	GF_List * elements;
-} Playlist;
+	Bool is_ended;
+	GF_List *elements; /*PlaylistElement*/
+};
+typedef struct s_playList Playlist;
 
-typedef enum e_playlistElementType  { TYPE_PLAYLIST, TYPE_STREAM, TYPE_UNKNOWN} PlaylistElementType;
+typedef enum e_playlistElementType  { TYPE_PLAYLIST, TYPE_MEDIA, TYPE_UNKNOWN } PlaylistElementType;
 
 /**
  * The Structure containing the playlist element
  */
-typedef struct s_playlistElement {
-	int durationInfo;
-	u64 byteRangeStart, byteRangeEnd;
+struct s_playlistElement {
+	int duration_info;
+	u64 byte_range_start, byte_range_end;
 	int bandwidth, width, height;
-	char * title;
-	char * codecs;
-	char * url;
-	PlaylistElementType elementType;
+	char *title;
+	char *codecs;
+	char *url;
+	PlaylistElementType element_type;
 	union {
 		Playlist playlist;
-		Stream stream;
+		Media media;
 	} element;
+};
+typedef struct s_playlistElement PlaylistElement;
 
-} PlaylistElement;
-
-typedef struct s_program {
-	int programId;
-	GF_List * bitrates;
-	int currentBitrateIndex;
+struct s_stream {
+	int program_id;
+	GF_List *variants; /*PlaylistElement*/
 	int computed_duration;
-} Program;
-
+};
+typedef struct s_stream Stream;
 
 /**
  * The root playlist, can contains several PlaylistElements structures
  */
-typedef struct s_variantPlaylist {
-	GF_List * programs;
-	int currentProgram;
-	Bool playlistNeedsRefresh;
-} VariantPlaylist;
-
-/**
- * Creates a new playlist
- * \return NULL if playlist could not be allocated
- *
-Playlist * playlist_new();
-*/
-/**
- * Deletes a given playlist and all of its sub elements
- *
-GF_Err playlist_del(Playlist *);
-*/
-
-/**
- * Deletes an Playlist element
- */
-GF_Err playlist_element_del(PlaylistElement *);
-
-/**
- * Creates a new program properly initialized
- */
-Program * program_new(int programId);
-
-/**
- * Deletes the specified program
- */
-GF_Err program_del(Program * program);
-
-/**
- * Creates an Playlist element.
- * This element can be either a playlist of a stream according to first parameter.
- * \return NULL if element could not be created. Elements will be deleted recusively
- */
-PlaylistElement * playlist_element_new(PlaylistElementType elementType, const char * url, const char * title, const char *codecs, int durationInfo, u64 byteRangeStart, u64 byteRangeEnd);
-
-/**
- * Creates a new VariantPlaylist
- * \return NULL if VariantPlaylist element could not be allocated
- */
-VariantPlaylist * variant_playlist_new();
-
-/**
- * Deletes the given VariantPlaylist and all of its sub elements
- */
-GF_Err variant_playlist_del(VariantPlaylist *);
-
-GF_Err playlist_element_dump(const PlaylistElement *e, int indent);
-
-GF_Err variant_playlist_dump(const VariantPlaylist *);
-
-Program * variant_playlist_find_matching_program(const VariantPlaylist *, const u32 programId);
-
-Program * variant_playlist_get_current_program(const VariantPlaylist *);
-
+struct s_masterPlaylist {
+	GF_List *streams; /*Stream*/
+	int current_stream;
+	Bool playlist_needs_refresh;
+};
+typedef struct s_masterPlaylist MasterPlaylist;
 
 
 /**
@@ -177,7 +97,7 @@ Program * variant_playlist_get_current_program(const VariantPlaylist *);
  * \param baseURL The base URL of the playlist
  * \return GF_OK if playlist valid
  */
-GF_Err gf_m3u8_parse_master_playlist(const char * file, VariantPlaylist ** playlist, const char * baseURL);
+GF_Err gf_m3u8_parse_master_playlist(const char *file, MasterPlaylist **playlist, const char *baseURL);
 
 /**
  * Parse the given playlist file as a subplaylist of an existing playlist
@@ -188,7 +108,11 @@ GF_Err gf_m3u8_parse_master_playlist(const char * file, VariantPlaylist ** playl
  * \param sub_playlist existing subplaylist element in the playlist in which the playlist is parsed
  * \return GF_OK if playlist valid
  */
-GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const char * baseURL, Program * in_program, PlaylistElement *sub_playlist);
+GF_Err gf_m3u8_parse_sub_playlist(const char *file, MasterPlaylist **playlist, const char *baseURL, Stream *in_program, PlaylistElement *sub_playlist);
 
-#endif /* M3U8_PLAYLIST_H */
+/**
+ * Deletes the given MasterPlaylist and all of its sub elements
+ */
+GF_Err gf_m3u8_variant_playlist_del(MasterPlaylist *playlist);
 
+#endif /* M3U8_PLAYLIST_H */
diff --git a/modules/mpd_in/mpd_in.c b/modules/mpd_in/mpd_in.c
index fdc5bd1ec5..c69431753f 100644
--- a/modules/mpd_in/mpd_in.c
+++ b/modules/mpd_in/mpd_in.c
@@ -89,10 +89,10 @@ const char * MPD_M3U8_EXT = "m3u8 m3u";
 static u32 MPD_RegisterMimeTypes(const GF_InputService *plug)
 {
 	u32 i, c;
-	for (i = 0 ; GF_DASH_MPD_MIME_TYPES[i]; i++)
+	for (i=0; GF_DASH_MPD_MIME_TYPES[i]; i++)
 		gf_service_register_mime (plug, GF_DASH_MPD_MIME_TYPES[i], MPD_MPD_EXT, MPD_MPD_DESC);
 	c = i;
-	for (i = 0 ; GF_DASH_M3U8_MIME_TYPES[i]; i++)
+	for (i=0; GF_DASH_M3U8_MIME_TYPES[i]; i++)
 		gf_service_register_mime(plug, GF_DASH_M3U8_MIME_TYPES[i], MPD_M3U8_EXT, MPD_M3U8_DESC);
 	return c+i;
 }
@@ -102,16 +102,16 @@ Bool MPD_CanHandleURL(GF_InputService *plug, const char *url)
 	u32 i;
 	char *sExt;
 	if (!plug || !url)
-		return 0;
+		return GF_FALSE;
 	sExt = strrchr(url, '.');
 	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD_IN] Received Can Handle URL request from terminal for %s\n", url));
-	for (i = 0 ; GF_DASH_MPD_MIME_TYPES[i]; i++) {
+	for (i=0; GF_DASH_MPD_MIME_TYPES[i]; i++) {
 		if (gf_service_check_mime_register(plug, GF_DASH_MPD_MIME_TYPES[i], MPD_MPD_EXT, MPD_MPD_DESC, sExt))
-			return 1;
+			return GF_TRUE;
 	}
-	for (i = 0 ; GF_DASH_M3U8_MIME_TYPES[i]; i++) {
+	for (i=0; GF_DASH_M3U8_MIME_TYPES[i]; i++) {
 		if (gf_service_check_mime_register(plug, GF_DASH_M3U8_MIME_TYPES[i], MPD_M3U8_EXT, MPD_M3U8_DESC, sExt))
-			return 1;
+			return GF_TRUE;
 	}
 
 	return gf_dash_check_mpd_root_type(url);
@@ -147,7 +147,7 @@ void mpdin_data_packet(GF_ClientService *service, LPNETCHANNEL ns, char *data, u
 	GF_MPD_In *mpdin = (GF_MPD_In*) service->ifce->priv;
 	GF_Channel *ch;
 	GF_MPDGroup *group;
-	Bool do_map_time = 0;
+	Bool do_map_time = GF_FALSE;
 	if (!ns || !hdr) {
 		mpdin->fn_data_packet(service, ns, data, data_size, hdr, reception_status);
 		return;
@@ -179,14 +179,14 @@ void mpdin_data_packet(GF_ClientService *service, LPNETCHANNEL ns, char *data, u
 			}
 			scale = ch->esd->slConfig->timestampResolution;
 			scale /= 1000;
-			dur = (u64) (scale * gf_dash_get_period_duration(mpdin->dash) );
+			dur = (u64) (scale * gf_dash_get_period_duration(mpdin->dash));
 			if (dur) {
 				group->max_cts_in_period = group->pto + dur;
 			} else {
 				group->max_cts_in_period = 0;
 			}
 
-			start = (u64) (scale * gf_dash_get_period_start(mpdin->dash) );
+			start = (u64) (scale * gf_dash_get_period_start(mpdin->dash));
 			group->pto -= start;
 		}
 		//filter any packet outside the current period
@@ -312,14 +312,14 @@ static GF_Err MPD_ClientQuery(GF_InputService *ifce, GF_NetworkCommand *param)
 			gf_dash_group_discard_segment(mpdin->dash, group_idx);
 		}
 
-		while (gf_dash_is_running(mpdin->dash) ) {
+		while (gf_dash_is_running(mpdin->dash)) {
 			group_done=0;
 			nb_segments_cached = gf_dash_group_get_num_segments_ready(mpdin->dash, group_idx, &group_done);
 			if (nb_segments_cached>=1)
 				break;
 
 			if (group_done) {
-				if (!gf_dash_get_period_switch_status(mpdin->dash) && !gf_dash_in_last_period(mpdin->dash) ) {
+				if (!gf_dash_get_period_switch_status(mpdin->dash) && !gf_dash_in_last_period(mpdin->dash)) {
 					GF_NetworkCommand com;
 					param->url_query.in_end_of_period = 1;
 					memset(&com, 0, sizeof(GF_NetworkCommand));
@@ -378,7 +378,7 @@ static GF_Err MPD_ClientQuery(GF_InputService *ifce, GF_NetworkCommand *param)
 
 #ifndef GPAC_DISABLE_LOG
 		{
-			u32 timer2 = gf_sys_clock() - timer ;
+			u32 timer2 = gf_sys_clock() - timer;
 			if (timer2 > 1000) {
 				GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD_IN] Waiting for download to end took a long time : %u ms\n", timer2));
 			}
@@ -387,7 +387,7 @@ static GF_Err MPD_ClientQuery(GF_InputService *ifce, GF_NetworkCommand *param)
 			} else {
 				GF_LOG(GF_LOG_INFO, GF_LOG_DASH, ("[MPD_IN] Next Segment is %s\n", src_url));
 			}
-			GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD_IN] Waited %d ms - Elements in cache: %u/%u\n\tCache file name %s\n\tsegment start time %g sec\n", timer2, gf_dash_group_get_num_segments_ready(mpdin->dash, group_idx, &group_done), gf_dash_group_get_max_segments_in_cache(mpdin->dash, group_idx), param->url_query.next_url, gf_dash_group_current_segment_start_time(mpdin->dash, group_idx)  ));
+			GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD_IN] Waited %d ms - Elements in cache: %u/%u\n\tCache file name %s\n\tsegment start time %g sec\n", timer2, gf_dash_group_get_num_segments_ready(mpdin->dash, group_idx, &group_done), gf_dash_group_get_max_segments_in_cache(mpdin->dash, group_idx), param->url_query.next_url, gf_dash_group_current_segment_start_time(mpdin->dash, group_idx)));
 		}
 #endif
 	}
@@ -506,7 +506,7 @@ static void mpdin_dash_segment_netio(void *cbk, GF_NETIO_Parameter *param)
 
 	if (param->msg_type == GF_NETIO_PARSE_HEADER) {
 		if (!strcmp(param->name, "Dash-Newest-Segment")) {
-			gf_dash_resync_to_segment(group->mpdin->dash, param->value, gf_dm_sess_get_header(param->sess, "Dash-Oldest-Segment") );
+			gf_dash_resync_to_segment(group->mpdin->dash, param->value, gf_dm_sess_get_header(param->sess, "Dash-Oldest-Segment"));
 		}
 	}
 
@@ -561,7 +561,7 @@ GF_DASHFileIOSession mpdin_dash_io_create(GF_DASHFileIO *dashio, Bool persistent
 	} else {
 		sess = gf_service_download_new(mpdin->service, url, flags, NULL, NULL);
 	}
-	return (GF_DASHFileIOSession ) sess;
+	return (GF_DASHFileIOSession) sess;
 }
 void mpdin_dash_io_del(GF_DASHFileIO *dashio, GF_DASHFileIOSession session)
 {
@@ -782,7 +782,7 @@ GF_Err mpdin_dash_io_on_dash_event(GF_DASHFileIO *dashio, GF_DASHEventType dash_
 			GF_MPDGroup *group = gf_dash_get_group_udta(mpdin->dash, group_idx);
 			if (group) {
 				GF_NetworkCommand com;
-				memset(&com, 0, sizeof(GF_NetworkCommand) );
+				memset(&com, 0, sizeof(GF_NetworkCommand));
 
 				com.command_type = GF_NET_SERVICE_EVENT;
 				com.send_event.evt.type = GF_EVENT_QUALITY_SWITCHED;
@@ -901,12 +901,11 @@ GF_Err MPD_ConnectService(GF_InputService *plug, GF_ClientService *serv, const c
 	else if (opt && !strcmp(opt, "none")) mpdin->buffer_mode = MPDIN_BUFFER_NONE;
 	else mpdin->buffer_mode = MPDIN_BUFFER_MIN;
 
-
 	opt = gf_modules_get_option((GF_BaseInterface *)plug, "DASH", "LowLatency");
 	if (!opt) gf_modules_set_option((GF_BaseInterface *)plug, "DASH", "LowLatency", "no");
 
-	if (opt && !strcmp(opt, "chunk") ) mpdin->use_low_latency = 1;
-	else if (opt && !strcmp(opt, "always") ) mpdin->use_low_latency = 2;
+	if (opt && !strcmp(opt, "chunk")) mpdin->use_low_latency = 1;
+	else if (opt && !strcmp(opt, "always")) mpdin->use_low_latency = 2;
 	else mpdin->use_low_latency = 0;
 
 	opt = gf_modules_get_option((GF_BaseInterface *)plug, "DASH", "AllowAbort");
@@ -987,7 +986,7 @@ GF_Err MPD_ConnectService(GF_InputService *plug, GF_ClientService *serv, const c
 	/*dash thread starts at the end of gf_dash_open */
 	e = gf_dash_open(mpdin->dash, url);
 	if (e) {
-		GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("[MPD_IN] Error - cannot initialize DASH Client for %s: %s\n", url, gf_error_to_string(e) ));
+		GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("[MPD_IN] Error - cannot initialize DASH Client for %s: %s\n", url, gf_error_to_string(e)));
 		mpdin->fn_connect_ack(mpdin->service, NULL, e);
 		return GF_OK;
 	}
@@ -1021,7 +1020,7 @@ static GF_Descriptor *MPD_GetServiceDesc(GF_InputService *plug, u32 expect_type,
 GF_Err MPD_CloseService(GF_InputService *plug)
 {
 	GF_MPD_In *mpdin = (GF_MPD_In*) plug->priv;
-	assert( mpdin );
+	assert(mpdin);
 	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD_IN] Received Close Service (%p) request from terminal\n", mpdin->service));
 
 	mpdin->closed = 1;
@@ -1041,7 +1040,7 @@ GF_Err MPD_ServiceCommand(GF_InputService *plug, GF_NetworkCommand *com)
 	GF_MPD_In *mpdin = (GF_MPD_In*) plug->priv;
 	GF_InputService *segment_ifce = NULL;
 
-	if (!plug || !plug->priv || !com ) return GF_SERVICE_ERROR;
+	if (!plug || !plug->priv || !com) return GF_SERVICE_ERROR;
 
 	segment_ifce = MPD_GetInputServiceForChannel(mpdin, com->base.on_channel);
 
@@ -1173,7 +1172,7 @@ GF_Err MPD_ServiceCommand(GF_InputService *plug, GF_NetworkCommand *com)
 
 	case GF_NET_CHAN_BUFFER:
 		/*get it from MPD minBufferTime - if not in low latency mode, indicate the value given in MPD (not possible to fetch segments earlier) - to be more precise we should get the min segment duration for this group*/
-		if (!mpdin->use_low_latency && (mpdin->buffer_mode>=MPDIN_BUFFER_MIN) ) {
+		if (!mpdin->use_low_latency && (mpdin->buffer_mode>=MPDIN_BUFFER_MIN)) {
 			u32 max = gf_dash_get_min_buffer_time(mpdin->dash);
 			if (max>com->buffer.max)
 				com->buffer.max = max;
@@ -1273,7 +1272,7 @@ GF_Err MPD_ServiceCommand(GF_InputService *plug, GF_NetworkCommand *com)
 
 			//to remove once we manage to keep the service alive
 			/*don't forward commands if a switch of period is to be scheduled, we are killing the service anyway ...*/
-			if (gf_dash_get_period_switch_status(mpdin->dash) ) return GF_OK;
+			if (gf_dash_get_period_switch_status(mpdin->dash)) return GF_OK;
 		}
 
 		gf_dash_group_select(mpdin->dash, idx, GF_TRUE);
@@ -1285,7 +1284,7 @@ GF_Err MPD_ServiceCommand(GF_InputService *plug, GF_NetworkCommand *com)
 			u32 timescale;
 			com->play.start_range = gf_dash_group_get_start_range(mpdin->dash, idx);
 			gf_dash_group_get_presentation_time_offset(mpdin->dash, idx, &pto, &timescale);
-			com->play.start_range += ((Double)pto ) / timescale;
+			com->play.start_range += ((Double)pto) / timescale;
 		}
 
 		return segment_ifce->ServiceCommand(segment_ifce, com);
@@ -1399,7 +1398,7 @@ void ShutdownInterface(GF_BaseInterface *bi)
 	if (bi->InterfaceType!=GF_NET_CLIENT_INTERFACE) return;
 
 	mpdin = (GF_MPD_In*) ((GF_InputService*)bi)->priv;
-	assert( mpdin );
+	assert(mpdin);
 
 	if (mpdin->dash)
 		gf_dash_del(mpdin->dash);
diff --git a/src/media_tools/dash_client.c b/src/media_tools/dash_client.c
index 5f7c7cc6b3..d94e966262 100644
--- a/src/media_tools/dash_client.c
+++ b/src/media_tools/dash_client.c
@@ -373,7 +373,7 @@ Bool gf_dash_check_mpd_root_type(const char *local_url)
 	if (local_url) {
 		char *rtype = gf_xml_get_root_type(local_url, NULL);
 		if (rtype) {
-			Bool handled = 0;
+			Bool handled = GF_FALSE;
 			if (!strcmp(rtype, "MPD")) {
 				handled = 1;
 			}
@@ -447,7 +447,7 @@ static void gf_dash_group_timeline_setup(GF_MPD *mpd, GF_DASH_Group *group, u64
 	if (current_time < availabilityStartTime) {
 		//if more than 1 sec consider we have a pb
 		if (availabilityStartTime - current_time >= 1000) {
-			Bool broken_timing = 1;
+			Bool broken_timing = GF_TRUE;
 #ifndef _WIN32_WCE
 			time_t gtime1, gtime2;
 			struct tm *t1, *t2;
@@ -700,15 +700,15 @@ static void gf_dash_group_timeline_setup(GF_MPD *mpd, GF_DASH_Group *group, u64
 * \param mime the mime-type to check
 * \return true if mime-type if MPD-OK
 */
-static Bool gf_dash_is_dash_mime(const char * mime) {
+static Bool gf_dash_is_dash_mime(const char *mime) {
 	u32 i;
 	if (!mime)
-		return 0;
+		return GF_FALSE;
 	for (i = 0 ; GF_DASH_MPD_MIME_TYPES[i] ; i++) {
 		if ( !stricmp(mime, GF_DASH_MPD_MIME_TYPES[i]))
 			return 1;
 	}
-	return 0;
+	return GF_FALSE;
 }
 
 /*!
@@ -735,7 +735,7 @@ static Bool gf_dash_is_m3u8_mime(const char *url, const char * mime) {
 GF_EXPORT
 GF_Err gf_dash_group_check_bandwidth(GF_DashClient *dash, u32 idx)
 {
-	Bool default_switch_mode = 0;
+	Bool default_switch_mode = GF_FALSE;
 	u32 download_rate, set_idx, time_since_start, done, tot_size, time_until_end;
 	GF_DASH_Group *group = gf_list_get(dash->groups, idx);
 	if (!group) return GF_BAD_PARAM;
@@ -837,8 +837,8 @@ GF_Err gf_dash_group_check_bandwidth(GF_DashClient *dash, u32 idx)
 GF_Err gf_dash_download_resource(GF_DASHFileIO *dash_io, GF_DASHFileIOSession *sess, const char *url, u64 start_range, u64 end_range, u32 persistent_mode, GF_DASH_Group *group)
 {
 	s32 group_idx = -1;
-	Bool had_sess = 0;
-	Bool retry = 1;
+	Bool had_sess = GF_FALSE;
+	Bool retry = GF_TRUE;
 	GF_Err e;
 
 	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[DASH] Downloading %s starting at UTC "LLU" ms\n", url, gf_net_get_utc() ));
@@ -1013,7 +1013,7 @@ static void gf_dash_get_timeline_duration(GF_MPD *mpd, GF_MPD_Period *period, GF
 static void gf_dash_get_segment_duration(GF_MPD_Representation *rep, GF_MPD_AdaptationSet *set, GF_MPD_Period *period, GF_MPD *mpd, u32 *nb_segments, Double *max_seg_duration)
 {
 	Double mediaDuration;
-	Bool single_segment = 0;
+	Bool single_segment = GF_FALSE;
 	u32 timescale;
 	u64 duration;
 	GF_MPD_SegmentTimeline *timeline = NULL;
@@ -1535,7 +1535,7 @@ static GF_Err gf_dash_update_manifest(GF_DashClient *dash)
 	char * purl;
 	Double timeline_start_time;
 	GF_MPD *new_mpd;
-	Bool fetch_only = 0;
+	Bool fetch_only = GF_FALSE;
 
 	if (!dash->mpd_dnload) {
 		local_url = purl = NULL;
@@ -1782,7 +1782,7 @@ static GF_Err gf_dash_update_manifest(GF_DashClient *dash)
 
 				for (i=0; i<gf_list_count(new_segments); i++) {
 					GF_MPD_SegmentURL *new_seg = gf_list_get(new_segments, i);
-					Bool found = 0;
+					Bool found = GF_FALSE;
 					for (j=0; j<gf_list_count(segments); j++) {
 						GF_MPD_SegmentURL *seg = gf_list_get(segments, j);
 						if (seg->media && new_seg->media && !strcmp(seg->media, new_seg->media)) {
@@ -1994,7 +1994,7 @@ static void gf_dash_switch_group_representation(GF_DashClient *mpd, GF_DASH_Grou
 	u32 i, bandwidth, min_bandwidth;
 	GF_MPD_Representation *rep_sel = NULL;
 	GF_MPD_Representation *min_rep_sel = NULL;
-	Bool min_bandwidth_selected = 0;
+	Bool min_bandwidth_selected = GF_FALSE;
 	bandwidth = 0;
 	min_bandwidth = (u32) -1;
 
@@ -2081,7 +2081,7 @@ static GF_Err gf_dash_download_init_segment(GF_DashClient *dash, GF_DASH_Group *
 		return GF_BAD_PARAM;
 	gf_mx_p(dash->dl_mutex);
 
-	assert( group->adaptation_set && group->adaptation_set->representations );
+	assert(group->adaptation_set && group->adaptation_set->representations);
 	rep = gf_list_get(group->adaptation_set->representations, group->active_rep_index);
 	if (!rep) {
 		gf_mx_v(dash->dl_mutex);
@@ -2240,7 +2240,7 @@ static GF_Err gf_dash_download_init_segment(GF_DashClient *dash, GF_DASH_Group *
 		}
 
 		if (stricmp(mime, mime_type)) {
-			Bool valid = 0;
+			Bool valid = GF_FALSE;
 			char *stype1, *stype2;
 			stype1 = strchr(mime_type, '/');
 			stype2 = strchr(mime, '/');
@@ -2442,7 +2442,7 @@ GF_Err gf_dash_setup_groups(GF_DashClient *dash)
 	for (i=0; i<count; i++) {
 		Double seg_dur;
 		GF_DASH_Group *group;
-		Bool found = 0;
+		Bool found = GF_FALSE;
 		Bool has_dependent_representations = GF_FALSE;
 		GF_MPD_AdaptationSet *set = gf_list_get(period->adaptation_sets, i);
 		for (j=0; j<gf_list_count(dash->groups); j++) {
@@ -2776,12 +2776,12 @@ static GF_Err gf_dash_setup_single_index_mode(GF_DASH_Group *group)
 		char *sidx_file = NULL;
 		u64 duration, index_start_range, index_end_range, init_start_range, init_end_range;
 		Bool index_in_base, init_in_base;
-		Bool init_needs_byte_range = 0;
-		Bool has_seen_sidx = 0;
-		Bool is_isom = 1;
+		Bool init_needs_byte_range = GF_FALSE;
+		Bool has_seen_sidx = GF_FALSE;
+		Bool is_isom = GF_TRUE;
 		rep = gf_list_get(group->adaptation_set->representations, i);
 
-		index_in_base = init_in_base = 0;
+		index_in_base = init_in_base = GF_FALSE;
 		e = gf_dash_resolve_url(group->dash->mpd, rep, group, group->dash->base_url, GF_MPD_RESOLVE_URL_INIT, 0, &init_url, &init_start_range, &init_end_range, &duration, &init_in_base);
 		if (e) goto exit;
 
@@ -3039,8 +3039,8 @@ static GF_Err gf_dash_setup_period(GF_DashClient *dash)
 		u32 active_rep, nb_rep;
 		const char *mime_type;
 		u32 nb_rep_ok = 0;
-		Bool disabled = 0;
-		Bool cp_supported = 0;
+		Bool disabled = GF_FALSE;
+		Bool cp_supported = GF_FALSE;
 		GF_DASH_Group *group = gf_list_get(dash->groups, group_i);
 
 		if ((dash->debug_group_index>=0) && (group_i != (u32) dash->debug_group_index)) {
@@ -3218,7 +3218,7 @@ static void dash_do_rate_adaptation(GF_DashClient *dash, GF_DASH_Group *group, G
 {
 	Double bitrate, time, speed;
 	u32 k, dl_rate;
-	Bool go_up = 0;
+	Bool go_up = GF_FALSE;
 	u32 nb_inter_rep = 0;
 	GF_MPD_Representation *new_rep;
 	u32 total_size, bytes_per_sec;
@@ -3282,7 +3282,7 @@ static void dash_do_rate_adaptation(GF_DashClient *dash, GF_DASH_Group *group, G
 	}
 
 	if (!dash->disable_switching && new_rep && (new_rep!=rep)) {
-		Bool do_switch = 1;
+		Bool do_switch = GF_TRUE;
 		//if we're switching to the next upper bitrate (no intermediate bitrates), do not immediately switch
 		//but for a given number of segments - this avoids fluctuation in the quality
 		if (go_up && ! nb_inter_rep) {
@@ -3358,9 +3358,9 @@ static u32 dash_main_thread_proc(void *par)
 	GF_DashClient *dash = (GF_DashClient*) par;
 	GF_MPD_Representation *rep;
 	u32 i, group_count, ret = 0;
-	Bool go_on = 1;
+	Bool go_on = GF_TRUE;
 	u32 min_wait = 0;
-	Bool first_period_in_mpd = 1;
+	Bool first_period_in_mpd = GF_TRUE;
 	char *new_base_seg_url;
 	assert(dash);
 	if (!dash->mpd) {
@@ -3457,8 +3457,8 @@ static u32 dash_main_thread_proc(void *par)
 					GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[DASH] Updated MPD in %d ms\n", diff));
 				}
 			} else {
-				Bool all_groups_done = 1;
-				Bool cache_full = 1;
+				Bool all_groups_done = GF_TRUE;
+				Bool cache_full = GF_TRUE;
 
 				/*wait if nothing is ready to be downloaded*/
 				if (min_wait>1) {
@@ -3539,7 +3539,7 @@ static u32 dash_main_thread_proc(void *par)
 		for (i=0; i<group_count; i++) {
 			//commented out as we end up doing too many requets
 #if 0
-			Bool in_segment_avail_time=0;
+			Bool in_segment_avail_time = GF_FALSE;
 #endif
 			u64 start_range, end_range;
 			Bool use_byterange;
@@ -3841,8 +3841,8 @@ static u32 dash_main_thread_proc(void *par)
 				gf_mx_p(dash->dl_mutex);
 
 				assert(group->nb_cached_segments<group->max_cached_segments);
-				assert( local_file_name );
-				if (! empty_file) {
+				assert(local_file_name);
+				if (!empty_file) {
 
 					group->cached[group->nb_cached_segments].cache = gf_strdup(local_file_name);
 					group->cached[group->nb_cached_segments].url = gf_strdup( resource_name );
@@ -3944,11 +3944,11 @@ static u32 gf_dash_period_index_from_time(GF_DashClient *dash, u32 time)
 static void gf_dash_download_stop(GF_DashClient *dash)
 {
 	u32 i;
-	assert( dash );
+	assert(dash);
 	if (dash->groups) {
 		for (i=0; i<gf_list_count(dash->groups); i++) {
 			GF_DASH_Group *group = gf_list_get(dash->groups, i);
-			assert( group );
+			assert(group);
 			if ((group->selection == GF_DASH_GROUP_SELECTED) && group->segment_download) {
 				if (group->segment_download)
 					dash->dash_io->abort(dash->dash_io, group->segment_download);
@@ -4167,7 +4167,7 @@ GF_Err gf_dash_open(GF_DashClient *dash, const char *manifest_url)
 	GF_Err e;
 	GF_MPD_Period *period;
 	GF_DOMParser *mpd_parser;
-	Bool is_local = 0;
+	Bool is_local = GF_FALSE;
 
 	if (!dash || !manifest_url) return GF_BAD_PARAM;
 
@@ -4350,8 +4350,7 @@ GF_Err gf_dash_open(GF_DashClient *dash, const char *manifest_url)
 GF_EXPORT
 void gf_dash_close(GF_DashClient *dash)
 {
-	assert( dash );
-
+	assert(dash);
 	gf_dash_download_stop(dash);
 
 	gf_mx_p(dash->dl_mutex);
@@ -4705,7 +4704,7 @@ const char *gf_dash_group_get_segment_init_url(GF_DashClient *dash, u32 idx, u64
 GF_EXPORT
 void gf_dash_group_select(GF_DashClient *dash, u32 idx, Bool select)
 {
-	Bool needs_resetup = 0;
+	Bool needs_resetup = GF_FALSE;
 	GF_DASH_Group *group = gf_list_get(dash->groups, idx);
 	if (!group) return;
 	if (group->selection == GF_DASH_GROUP_NOT_SELECTABLE)
@@ -4775,7 +4774,7 @@ void gf_dash_groups_set_language(GF_DashClient *dash, const char *lang_code_rfc_
 			//check we didn't select one AS in this group in the previous pass or in this pass
 			if (group->adaptation_set->group>=0) {
 				u32 k;
-				Bool found = 0;
+				Bool found = GF_FALSE;
 				for (k=0; k<gf_list_count(groups_selected); k++) {
 					GF_DASH_Group *ag = gf_list_get(groups_selected, k);
 
@@ -4893,10 +4892,10 @@ void gf_dash_group_discard_segment(GF_DashClient *dash, u32 idx)
 			if (!group->local_files && !dash->keep_files)
 				dash->dash_io->delete_cache_file(dash->dash_io, group->segment_download, group->urlToDeleteNext);
 
-			gf_free( group->urlToDeleteNext);
+			gf_free(group->urlToDeleteNext);
 			group->urlToDeleteNext = NULL;
 		}
-		assert( group->cached[0].url );
+		assert(group->cached[0].url);
 
 		if (group->dont_delete_first_segment) {
 			group->dont_delete_first_segment = 0;
@@ -5076,7 +5075,7 @@ GF_Err gf_dash_group_probe_current_download_segment_location(GF_DashClient *dash
 GF_EXPORT
 void gf_dash_seek(GF_DashClient *dash, Double start_range)
 {
-	Bool is_dynamic = 0;
+	Bool is_dynamic = GF_FALSE;
 	gf_mx_p(dash->dl_mutex);
 
 	GF_LOG(GF_LOG_INFO, GF_LOG_DASH, ("[DASH] Seek request - playing from %g\n", start_range));
diff --git a/src/media_tools/m3u8.c b/src/media_tools/m3u8.c
index 8a865a3394..dd15b31d91 100644
--- a/src/media_tools/m3u8.c
+++ b/src/media_tools/m3u8.c
@@ -1,8 +1,8 @@
 /**
 *			GPAC - Multimedia Framework C SDK
 *
-*			Authors: Pierre Souchay, Jean Le Feuvre
-*			Copyright (c) Telecom ParisTech 2010-2012
+*			Authors: Pierre Souchay, Jean Le Feuvre, Romain Bouqueau
+*			Copyright (c) Telecom ParisTech 2010-2012, Romain Bouqueau
 *					All rights reserved
 *
 *  This file is part of GPAC
@@ -26,23 +26,17 @@
 #define _GNU_SOURCE
 
 #include <gpac/internal/m3u8.h>
-#include <string.h>
-#include <stdio.h>
 #include <gpac/network.h>
 
-#define MYLOG(msg) GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, msg)
 
+GF_Err playlist_element_del(PlaylistElement * e);
 
-#if defined(WIN32) || defined(_WIN32_WCE)
-#define bzero(a, b) memset(a, 0x0, b)
-#endif
-
-GF_Err cleanup_list_of_elements(GF_List * list) {
+static GF_Err cleanup_list_of_elements(GF_List *list) {
 	GF_Err result = GF_OK;
 	if (list == NULL)
 		return result;
 	while (gf_list_count(list)) {
-		PlaylistElement * pl = (PlaylistElement *) gf_list_get(list, 0);
+		PlaylistElement *pl = (PlaylistElement *) gf_list_get(list, 0);
 		if (pl)
 			result |= playlist_element_del(pl);
 		gf_list_rem(list, 0);
@@ -51,7 +45,10 @@ GF_Err cleanup_list_of_elements(GF_List * list) {
 	return result;
 }
 
-GF_Err playlist_element_del(PlaylistElement * e) {
+/**
+ * Deletes an Playlist element
+ */
+static GF_Err playlist_element_del(PlaylistElement * e) {
 	GF_Err result = GF_OK;
 	if (e == NULL)
 		return result;
@@ -63,16 +60,16 @@ GF_Err playlist_element_del(PlaylistElement * e) {
 		gf_free(e->codecs);
 		e->codecs = NULL;
 	}
-	assert( e->url);
+	assert(e->url);
 	gf_free(e->url);
 	e->url = NULL;
 
-	switch (e->elementType) {
+	switch (e->element_type) {
 	case TYPE_UNKNOWN:
-	case TYPE_STREAM:
+	case TYPE_MEDIA:
 		break;
 	case TYPE_PLAYLIST:
-		assert( e->element.playlist.elements);
+		assert(e->element.playlist.elements);
 		result |= cleanup_list_of_elements(e->element.playlist.elements);
 		e->element.playlist.elements = NULL;
 	default:
@@ -82,72 +79,70 @@ GF_Err playlist_element_del(PlaylistElement * e) {
 	return result;
 }
 
-Program * program_new(int programId) {
-	Program * program = (Program*)gf_malloc(sizeof(Program));
+/**
+ * Creates a new program properly initialized
+ */
+static Stream* program_new(int program_id) {
+	Stream *program = (Stream *) gf_malloc(sizeof(Stream));
 	if (program == NULL) {
 		return NULL;
 	}
-	program->programId = programId;
-	program->bitrates = gf_list_new();
-	if (program->bitrates == NULL) {
+	program->program_id = program_id;
+	program->variants = gf_list_new();
+	if (program->variants == NULL) {
 		gf_free(program);
 		return NULL;
 	}
 	return program;
 }
 
-GF_Err program_del(Program * program) {
+/**
+ * Deletes the specified program
+ */
+static GF_Err program_del(Stream *program) {
 	GF_Err e = GF_OK;
 	if (program == NULL)
 		return e;
-	if ( program->bitrates) {
-		while (gf_list_count(program->bitrates)) {
-			GF_List * l = gf_list_get(program->bitrates, 0);
+	if (program->variants) {
+		while (gf_list_count(program->variants)) {
+			GF_List *l = gf_list_get(program->variants, 0);
 			cleanup_list_of_elements(l);
-			gf_list_rem(program->bitrates, 0);
+			gf_list_rem(program->variants, 0);
 		}
-		gf_list_del(program->bitrates);
+		gf_list_del(program->variants);
 	}
-	program->bitrates = NULL;
+	program->variants = NULL;
 	gf_free(program);
 	return e;
 }
 
-/*
-static GF_Err playlist_del(Playlist * pl){
-GF_Err result = GF_OK;
-if (pl == NULL)
-return result;
-if (pl->elements){
-result|= cleanup_list_of_elements(pl->elements);
-pl->elements = NULL;
-}
-gf_free(pl);
-return result;
-}*/
-
-PlaylistElement * playlist_element_new(PlaylistElementType elementType, const char * url, const char * title, const char *codecs, int durationInfo, u64 byteRangeStart, u64 byteRangeEnd) {
-	PlaylistElement * e = gf_malloc(sizeof(PlaylistElement));
-	bzero(e, sizeof(PlaylistElement));
-	assert( url );
+/**
+ * Creates an Playlist element.
+ * This element can be either a playlist of a stream according to first parameter.
+ * \return NULL if element could not be created. Elements will be deleted recursively
+ */
+static PlaylistElement* playlist_element_new(PlaylistElementType element_type, const char *url, const char *title, const char *codecs, int duration_info, u64 byte_range_start, u64 byte_range_end) {
+	PlaylistElement *e = gf_malloc(sizeof(PlaylistElement));
+	memset(e, 0, sizeof(PlaylistElement));
+	assert(url);
 	if (e == NULL)
 		return NULL;
-	e->durationInfo = durationInfo;
-	e->byteRangeStart = byteRangeStart;
-	e->byteRangeEnd = byteRangeEnd;
+	e->duration_info = duration_info;
+	e->byte_range_start = byte_range_start;
+	e->byte_range_end = byte_range_end;
 
 	e->title = (title ? gf_strdup(title) : NULL);
 	e->codecs = (codecs ? gf_strdup(codecs) : NULL);
-	assert( url);
+	assert(url);
 	e->url = gf_strdup(url);
 	e->bandwidth = 0;
-	e->elementType = elementType;
-	if (elementType == TYPE_PLAYLIST) {
-		e->element.playlist.is_ended = 0;
-		e->element.playlist.target_duration = durationInfo;
-		e->element.playlist.currentMediaSequence = 0;
-		e->element.playlist.mediaSequenceMin = 0;
-		e->element.playlist.mediaSequenceMax = 0;
+	e->element_type = element_type;
+	if (element_type == TYPE_PLAYLIST) {
+		e->element.playlist.is_ended = GF_FALSE;
+		e->element.playlist.target_duration = duration_info;
+		e->element.playlist.current_media_seq = 0;
+		e->element.playlist.media_seq_min = 0;
+		e->element.playlist.media_seq_max = 0;
 		e->element.playlist.elements = gf_list_new();
 		if (NULL == (e->element.playlist.elements)) {
 			if (e->title)
@@ -163,139 +158,93 @@ PlaylistElement * playlist_element_new(PlaylistElementType elementType, const ch
 			return NULL;
 		}
 	} else {
-		/* Nothing to do, stream is an empty structure */
+		/* Nothing to do, media is an empty structure */
 	}
 	assert(e->bandwidth == 0);
 	assert(e->url);
 	return e;
 }
-/*
-Playlist * playlist_new(){
-Playlist * pl = gf_malloc(sizeof(Playlist));
-if (pl == NULL)
-return NULL;
-pl->currentMediaSequence = 1;
-pl->target_duration = 0;
-pl->mediaSequenceMin = 0;
-pl->mediaSequenceMax = 0;
-pl->is_ended = 0;
-pl->elements = gf_list_new();
-if (pl->elements == NULL){
-gf_free(pl);
-return NULL;
-}
-return pl;
-}
-*/
 
-VariantPlaylist * variant_playlist_new ()
+/**
+ * Creates a new MasterPlaylist
+ * \return NULL if MasterPlaylist element could not be allocated
+ */
+MasterPlaylist* variant_playlist_new()
 {
-	VariantPlaylist * pl = (VariantPlaylist*)gf_malloc( sizeof(VariantPlaylist) );
+	MasterPlaylist *pl = (MasterPlaylist*)gf_malloc(sizeof(MasterPlaylist));
 	if (pl == NULL)
 		return NULL;
-	pl->programs = gf_list_new();
-	if (! pl->programs) {
-		gf_free( pl );
+	pl->streams = gf_list_new();
+	if (!pl->streams) {
+		gf_free(pl);
 		return NULL;
 	}
-	pl->currentProgram = -1;
-	pl->playlistNeedsRefresh = 1;
+	pl->current_stream = -1;
+	pl->playlist_needs_refresh = GF_TRUE;
 	return pl;
 }
 
-GF_Err variant_playlist_del(VariantPlaylist * playlist) {
+GF_Err gf_m3u8_variant_playlist_del(MasterPlaylist *playlist) {
 	if (playlist == NULL)
 		return GF_OK;
-	assert( playlist->programs);
-	while (gf_list_count(playlist->programs)) {
-		Program * p = gf_list_get(playlist->programs, 0);
+	assert(playlist->streams);
+	while (gf_list_count(playlist->streams)) {
+		Stream *p = gf_list_get(playlist->streams, 0);
 		assert(p);
-		while (gf_list_count( p->bitrates )) {
-			PlaylistElement * pl = gf_list_get(p->bitrates, 0);
-			assert( pl );
+		while (gf_list_count(p->variants)) {
+			PlaylistElement *pl = gf_list_get(p->variants, 0);
+			assert(pl);
 			playlist_element_del(pl);
-			gf_list_rem(p->bitrates, 0);
+			gf_list_rem(p->variants, 0);
 		}
-		gf_list_del(p->bitrates);
-		p->bitrates = NULL;
+		gf_list_del(p->variants);
+		p->variants = NULL;
 		program_del(p);
-		gf_list_rem(playlist->programs, 0);
+		gf_list_rem(playlist->streams, 0);
 	}
-	gf_list_del(playlist->programs);
-	playlist->programs = NULL;
+	gf_list_del(playlist->streams);
+	playlist->streams = NULL;
 	gf_free(playlist);
+
 	return GF_OK;
 }
 
-GF_Err playlist_element_dump(const PlaylistElement * e, int indent) {
+static GF_Err playlist_element_dump(const PlaylistElement *e, int indent) {
 	int i;
 	GF_Err r = GF_OK;
-	for (i = 0 ; i < indent; i++)
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, (" ") );
+	for (i=0; i<indent; i++)
+		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, (" "));
 	if (e == NULL) {
 		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] NULL PlaylistElement\n"));
 		return r;
 	}
 	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] PlayListElement[%p, title=%s, codecs=%s, duration=%d, bandwidth=%d, url=%s, type=%s]\n",
-	                                   (void*)e,
-	                                   e->title,
-	                                   e->codecs,
-	                                   e->durationInfo,
-	                                   e->bandwidth,
-	                                   e->url,
-	                                   e->elementType == TYPE_STREAM ? "stream" : "playlist"));
-	if (TYPE_PLAYLIST == e->elementType) {
+	                                   (void*)e, e->title, e->codecs, e->duration_info, e->bandwidth, e->url,
+	                                   e->element_type == TYPE_MEDIA ? "media" : "playlist"));
+	if (TYPE_PLAYLIST == e->element_type) {
 		int sz;
-		assert( e->element.playlist.elements);
+		assert(e->element.playlist.elements);
 		sz = gf_list_count(e->element.playlist.elements);
-		indent+=2;
-		for (i = 0 ; i < sz ; i++) {
-			PlaylistElement * el = gf_list_get(e->element.playlist.elements, i);
-			assert( el);
-			r|= playlist_element_dump( el, indent);
+		indent += 2;
+		for (i=0 ; i<sz; i++) {
+			PlaylistElement *elt = gf_list_get(e->element.playlist.elements, i);
+			assert(elt);
+			r |= playlist_element_dump(elt, indent);
 		}
 	}
 	return r;
 }
 
-GF_Err variant_playlist_dump(const VariantPlaylist * pl) {
-	int i, count;
-	GF_Err e = GF_OK;
-	if (pl == NULL) {
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] VariantPlaylist = NULL\n"));
-		return e;
-	}
-	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] VariantPlaylist = {\n"));
-	assert( pl->programs);
-	count = gf_list_count( pl->programs);
-	for (i = 0 ; i < count ; i++) {
-		int j, countj;
-		Program * p = gf_list_get(pl->programs, i);
-		assert( p );
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] program[programId=%d]{\n",  p->programId));
-		assert( p->bitrates );
-		countj = gf_list_count(p->bitrates);
-		for (j = 0; j < countj; j++) {
-			PlaylistElement * el = gf_list_get(p->bitrates, j);
-			assert(el);
-			e |= playlist_element_dump( el, 4);
-		}
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8] }\n"));
-	}
-	GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[M3U8]}\n"));
-	return e;
-}
-
-Program * variant_playlist_find_matching_program(const VariantPlaylist * pl, const u32 programId) {
+static Stream* variant_playlist_find_matching_program(const MasterPlaylist *pl, const u32 program_id) {
 	u32 count, i;
-	assert( pl);
-	assert( pl->programs);
-	assert(programId >= 0);
-	count = gf_list_count(pl->programs);
-	for (i = 0 ; i < count ; i++) {
-		Program * cur = gf_list_get(pl->programs, i);
-		assert( cur );
-		if (programId == cur->programId) {
+	assert(pl);
+	assert(pl->streams);
+	assert(program_id >= 0);
+	count = gf_list_count(pl->streams);
+	for (i=0; i<count; i++) {
+		Stream *cur = gf_list_get(pl->streams, i);
+		assert(cur);
+		if (program_id == cur->program_id) {
 			/* We found the program */
 			return cur;
 		}
@@ -303,70 +252,67 @@ Program * variant_playlist_find_matching_program(const VariantPlaylist * pl, con
 	return NULL;
 }
 
-Program * variant_playlist_get_current_program(const VariantPlaylist * pl) {
-	assert( pl );
-	return variant_playlist_find_matching_program(pl, pl->currentProgram);
-}
-
-
 
 typedef struct _s_accumulated_attributes {
-	char * title;
-	int durationInSeconds;
+	char *title;
+	int duration_in_seconds;
 	int bandwidth;
 	int width, height;
-	int programId;
-	char * codecs;
-	int targetDurationInSeconds;
-	int minMediaSequence;
-	int currentMediaSequence;
-	Bool isVariantPlaylist;
-	Bool isPlaylistEnded;
-	u64 byteRangeStart, byteRangeEnd;
+	int program_id;
+	char *codecs;
+	int target_duration_in_seconds;
+	int min_media_sequence;
+	int current_media_seq;
+	Bool is_variant_playlist;
+	Bool is_playlist_ended;
+	u64 byte_range_start, byte_range_end;
 } s_accumulated_attributes;
 
-static Bool safe_start_equals(const char * attribute, const char * line) {
+static Bool safe_start_equals(const char *attribute, const char *line) {
 	size_t len, atlen;
 	if (line == NULL)
-		return 0;
+		return GF_FALSE;
 	len = strlen(line);
 	atlen = strlen(attribute);
 	if (len < atlen)
-		return 0;
-	return 0 == strncmp(attribute, line, atlen);
+		return GF_FALSE;
+	return (0 == strncmp(attribute, line, atlen));
 }
 
-static char ** extractAttributes(const char * name, const char * line, const int numberOfAttributes) {
-	int sz, i, currentAttribute, start;
-	char ** ret;
-	u8 quote=0;
+static char** extractAttributes(const char *name, const char *line, const int num_attributes) {
+	int sz, i, curr_attribute, start;
+	char **ret;
+	u8 quote = 0;
 	int len = (u32) strlen(line);
 	start = (u32) strlen(name);
 	if (len <= start)
 		return NULL;
 	if (!safe_start_equals(name, line))
 		return NULL;
-	ret = gf_calloc((numberOfAttributes + 1 ), sizeof(char*));
-	currentAttribute = 0;
-	for (i = start ; i <= len ; i++) {
-		if (line[i] == '\0' || (!quote && line[i] == ',')  || (line[i] == quote) ) {
+	ret = gf_calloc((num_attributes + 1), sizeof(char*));
+	curr_attribute = 0;
+	for (i=start; i<=len; i++) {
+		if (line[i] == '\0' || (!quote && line[i] == ',')  || (line[i] == quote)) {
 			u32 spaces = 0;
 			sz = 1 + i - start;
-			while (line[start+spaces] == ' ') spaces++;
-			ret[currentAttribute] = gf_calloc( (1+sz-spaces), sizeof(char));
-			strncpy(ret[currentAttribute], &(line[start+spaces]), sz-spaces);
-			currentAttribute++;
+			while (line[start+spaces] == ' ')
+				spaces++;
+			ret[curr_attribute] = gf_calloc( (1+sz-spaces), sizeof(char));
+			strncpy(ret[curr_attribute], &(line[start+spaces]), sz-spaces);
+			curr_attribute++;
 			start = i+1;
 			if (start == len) {
 				return ret;
 			}
 		}
 		if ((line[i] == '\'') || (line[i] == '"'))  {
-			if (quote) quote = 0;
-			else quote = line[i];
+			if (quote)
+				quote = 0;
+			else
+				quote = line[i];
 		}
 	}
-	if (currentAttribute == 0) {
+	if (curr_attribute == 0) {
 		gf_free(ret);
 		return NULL;
 	}
@@ -374,28 +320,28 @@ static char ** extractAttributes(const char * name, const char * line, const int
 }
 
 /**
-* Parses the attributes and accumulate into the attributes structure
-*/
-static char ** parseAttributes(const char * line, s_accumulated_attributes * attributes) {
-	int intValue, i;
-	char ** ret;
-	char * endPtr;
-	char * utility;
+ * Parses the attributes and accumulate into the attributes structure
+ */
+static char** parseAttributes(const char *line, s_accumulated_attributes *attributes) {
+	int int_value, i;
+	char **ret;
+	char *end_ptr;
+	char *utility;
 	if (line == NULL)
 		return NULL;
 	if (!safe_start_equals("#EXT", line))
 		return NULL;
 	if (safe_start_equals("#EXT-X-ENDLIST", line)) {
-		attributes->isPlaylistEnded = 1;
+		attributes->is_playlist_ended = GF_TRUE;
 		return NULL;
 	}
 	ret = extractAttributes("#EXT-X-TARGETDURATION:", line, 1);
 	if (ret) {
 		/* #EXT-X-TARGETDURATION:<seconds> */
 		if (ret[0]) {
-			intValue = (s32) strtol(ret[0], &endPtr, 10);
-			if (endPtr != ret[0]) {
-				attributes->targetDurationInSeconds = intValue;
+			int_value = (s32) strtol(ret[0], &end_ptr, 10);
+			if (end_ptr != ret[0]) {
+				attributes->target_duration_in_seconds = int_value;
 			}
 		}
 		return ret;
@@ -404,10 +350,10 @@ static char ** parseAttributes(const char * line, s_accumulated_attributes * att
 	if (ret) {
 		/* #EXT-X-MEDIA-SEQUENCE:<number> */
 		if (ret[0]) {
-			intValue = (s32) strtol(ret[0], &endPtr, 10);
-			if (endPtr != ret[0]) {
-				attributes->minMediaSequence = intValue;
-				attributes->currentMediaSequence = intValue;
+			int_value = (s32)strtol(ret[0], &end_ptr, 10);
+			if (end_ptr != ret[0]) {
+				attributes->min_media_sequence = int_value;
+				attributes->current_media_seq = int_value;
 			}
 		}
 		return ret;
@@ -416,9 +362,9 @@ static char ** parseAttributes(const char * line, s_accumulated_attributes * att
 	if (ret) {
 		/* #EXTINF:<duration>,<title> */
 		if (ret[0]) {
-			intValue = (s32) strtol(ret[0], &endPtr, 10);
-			if (endPtr != ret[0]) {
-				attributes->durationInSeconds = intValue;
+			int_value = (s32) strtol(ret[0], &end_ptr, 10);
+			if (end_ptr != ret[0]) {
+				attributes->duration_in_seconds = int_value;
 			}
 		}
 		if (ret[1]) {
@@ -436,21 +382,21 @@ static char ** parseAttributes(const char * line, s_accumulated_attributes * att
 	if (ret) {
 		/* #EXT-X-STREAM-INF:[attribute=value][,attribute=value]* */
 		i = 0;
-		attributes->isVariantPlaylist = 1;
+		attributes->is_variant_playlist = GF_TRUE;
 		while (ret[i] != NULL) {
 			if (safe_start_equals("BANDWIDTH=", ret[i])) {
 				utility = &(ret[i][10]);
-				intValue = (s32) strtol(utility, &endPtr, 10);
-				if (endPtr != utility)
-					attributes->bandwidth = intValue;
+				int_value = (s32) strtol(utility, &end_ptr, 10);
+				if (end_ptr != utility)
+					attributes->bandwidth = int_value;
 			} else if (safe_start_equals("PROGRAM-ID=", ret[i])) {
 				utility = &(ret[i][11]);
-				intValue = (s32) strtol(utility, &endPtr, 10);
-				if (endPtr != utility)
-					attributes->programId = intValue;
+				int_value = (s32) strtol(utility, &end_ptr, 10);
+				if (end_ptr != utility)
+					attributes->program_id = int_value;
 			} else if (safe_start_equals("CODECS=\"", ret[i])) {
-				intValue = (u32) strlen(ret[i]);
-				if (ret[i][intValue-1] == '"') {
+				int_value = (u32) strlen(ret[i]);
+				if (ret[i][int_value-1] == '"') {
 					attributes->codecs = gf_strdup(&(ret[i][7]));
 				}
 			} else if (safe_start_equals("RESOLUTION=", ret[i])) {
@@ -472,8 +418,8 @@ static char ** parseAttributes(const char * line, s_accumulated_attributes * att
 			u64 begin, size;
 			if (sscanf(ret[0], LLU"@"LLU, &size, &begin) == 2) {
 				if (size) {
-					attributes->byteRangeStart = begin;
-					attributes->byteRangeEnd = begin + size - 1;
+					attributes->byte_range_start = begin;
+					attributes->byte_range_end = begin + size - 1;
 				} else {
 					GF_LOG(GF_LOG_ERROR, GF_LOG_DASH,("[M3U8] Invalid byte range %s\n", ret[0]));
 				}
@@ -487,20 +433,20 @@ static char ** parseAttributes(const char * line, s_accumulated_attributes * att
 #define M3U8_BUF_SIZE 2048
 
 GF_EXPORT
-GF_Err gf_m3u8_parse_master_playlist(const char * file, VariantPlaylist ** playlist, const char * baseURL)
+GF_Err gf_m3u8_parse_master_playlist(const char *file, MasterPlaylist **playlist, const char *baseURL)
 {
-	return parse_sub_playlist(file, playlist, baseURL, NULL, NULL);
+	return gf_m3u8_parse_sub_playlist(file, playlist, baseURL, NULL, NULL);
 }
 
-GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const char * baseURL, Program * in_program, PlaylistElement *sub_playlist)
+GF_Err gf_m3u8_parse_sub_playlist(const char *file, MasterPlaylist **playlist, const char *baseURL, Stream *in_program, PlaylistElement *sub_playlist)
 {
 	int len, i, currentLineNumber;
-	FILE * f=NULL;
+	FILE *f = NULL;
 	char *m3u8_payload;
 	u32 m3u8_size, m3u8pos;
-	VariantPlaylist * pl;
+	MasterPlaylist *pl;
 	char currentLine[M3U8_BUF_SIZE];
-	char ** attributes = NULL;
+	char **attributes = NULL;
 	s_accumulated_attributes attribs;
 
 	if (!strncmp(file, "gmem://", 7)) {
@@ -524,23 +470,23 @@ GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const
 	}
 	pl = *playlist;
 	currentLineNumber = 0;
-	bzero(&attribs, sizeof(s_accumulated_attributes));
+	memset(&attribs, 0, sizeof(s_accumulated_attributes));
 	attribs.bandwidth = 0;
-	attribs.durationInSeconds = 0;
-	attribs.targetDurationInSeconds = 0;
-	attribs.isVariantPlaylist = 0;
-	attribs.isPlaylistEnded = 0;
-	attribs.minMediaSequence = 0;
-	attribs.currentMediaSequence = 0;
-	m3u8pos=0;
+	attribs.duration_in_seconds = 0;
+	attribs.target_duration_in_seconds = 0;
+	attribs.is_variant_playlist = GF_FALSE;
+	attribs.is_playlist_ended = GF_FALSE;
+	attribs.min_media_sequence = 1;
+	attribs.current_media_seq = 0;
+	m3u8pos = 0;
 	while (1) {
-		char * eof;
+		char *eof;
 		if (f) {
 			if (!fgets(currentLine, sizeof(currentLine), f))
 				break;
 		} else {
-			u32 __idx=0;
-			if (m3u8pos>=m3u8_size)
+			u32 __idx = 0;
+			if (m3u8pos >= m3u8_size)
 				break;
 			while (1) {
 				currentLine[__idx] = m3u8_payload[m3u8pos];
@@ -559,14 +505,14 @@ GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const
 		eof = strchr(currentLine, '\n');
 		if (eof)
 			eof[0] = '\0';
-		len = (u32) strlen( currentLine);
+		len = (u32) strlen(currentLine);
 		if (len < 1)
 			continue;
 		if (currentLineNumber == 1) {
 			/* Playlist MUST start with #EXTM3U */
 			/*			if (len < 7 || strncmp("#EXTM3U", currentLine, 7)!=0) {
 							fclose(f);
-							variant_playlist_del(pl);
+							gf_m3u8_variant_playlist_del(pl);
 							GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("Failed to parse M3U8 File, it should start with #EXTM3U, but was : %s\n", currentLine));
 							return GF_STREAM_NOT_FOUND;
 						}
@@ -575,29 +521,29 @@ GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const
 		}
 		if (currentLine[0] == '#') {
 			/* A comment or a directive */
-			if (strncmp("#EXT", currentLine, 4)==0) {
+			if (strncmp("#EXT", currentLine, 4) == 0) {
 				attributes = parseAttributes(currentLine, &attribs);
 				if (attributes == NULL) {
-					MYLOG(("Comment at line %d : %s\n", currentLineNumber, currentLine));
+					GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("Comment at line %d : %s\n", currentLineNumber, currentLine));
 				} else {
-					MYLOG(("Directive at line %d: \"%s\", attributes=", currentLineNumber, currentLine));
+					GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("Directive at line %d: \"%s\", attributes=", currentLineNumber, currentLine));
 					i = 0;
 					while (attributes[i] != NULL) {
-						MYLOG((" [%d]='%s'", i, attributes[i]));
+						GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, (" [%d]='%s'", i, attributes[i]));
 						gf_free(attributes[i]);
 						attributes[i] = NULL;
 						i++;
 					}
-					MYLOG(("\n"));
+					GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("\n"));
 					gf_free(attributes);
 					attributes = NULL;
 				}
-				if (attribs.isPlaylistEnded) {
-					pl->playlistNeedsRefresh = 0;
+				if (attribs.is_playlist_ended) {
+					pl->playlist_needs_refresh = GF_FALSE;
 				}
 			}
 		} else {
-			char * fullURL = currentLine;
+			char *fullURL = currentLine;
 
 			if (gf_url_is_local(currentLine)) {
 				/*
@@ -609,180 +555,181 @@ GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const
 				num_chars = asprintf(&fullURL, "%s/%s", baseURL, currentLine);
 				}
 				if (num_chars < 0 || fullURL == NULL){
-				variant_playlist_del(*playlist);
+				gf_m3u8_variant_playlist_del(*playlist);
 				playlist = NULL;
 				return GF_OUT_OF_MEM;
 				}
 				} else */ {
 					fullURL = gf_url_concatenate(baseURL, currentLine);
 				}
-				assert( fullURL );
+				assert(fullURL);
 			}
 			{
 				u32 count;
-				PlaylistElement * currentPlayList = sub_playlist;
+				PlaylistElement *curr_playlist = sub_playlist;
 				/* First, we have to find the matching program */
-				Program * program = in_program;
-				if (!in_program) program = variant_playlist_find_matching_program(pl, attribs.programId);
+				Stream *program = in_program;
+				if (!in_program)
+					program = variant_playlist_find_matching_program(pl, attribs.program_id);
 				/* We did not found the program, we create it */
 				if (program == NULL) {
-					program = program_new(attribs.programId);
+					program = program_new(attribs.program_id);
 					if (program == NULL) {
 						/* OUT of memory */
-						variant_playlist_del(*playlist);
+						gf_m3u8_variant_playlist_del(*playlist);
 						if (f) fclose(f);
 						playlist = NULL;
 						return GF_OUT_OF_MEM;
 					}
-					gf_list_add(pl->programs, program);
-					if (pl->currentProgram < 0)
-						pl->currentProgram = program->programId;
+					gf_list_add(pl->streams, program);
+					if (pl->current_stream < 0)
+						pl->current_stream = program->program_id;
 				}
 
-				/* OK, we have a program, we have to choose the elements with same bandwidth */
-				assert( program );
-				assert( program->bitrates);
-				count = gf_list_count( program->bitrates);
-
-				if (!currentPlayList) {
-					for (i = 0; i < (s32) count; i++) {
-						PlaylistElement * itPlayListElement = gf_list_get(program->bitrates, i);
-						assert( itPlayListElement );
-						if (itPlayListElement->bandwidth == attribs.bandwidth) {
-							currentPlayList = itPlayListElement;
+				/* OK, we have a program, we have to choose the elements with the same bandwidth */
+				assert(program);
+				assert(program->variants);
+				count = gf_list_count(program->variants);
+
+				if (!curr_playlist) {
+					for (i=0; i<(s32)count; i++) {
+						PlaylistElement *i_playlist_element = gf_list_get(program->variants, i);
+						assert(i_playlist_element);
+						if (i_playlist_element->bandwidth == attribs.bandwidth) {
+							curr_playlist = i_playlist_element;
 							break;
 						}
 					}
 				}
 
-				if (attribs.isVariantPlaylist) {
+				if (attribs.is_variant_playlist) {
 					/* We are the Variant Playlist */
-					if (currentPlayList != NULL) {
-						/* should not happen, it means we redefine something previsouly added */
-						//assert( 0 );
+					if (curr_playlist != NULL) {
+						/* should not happen, it means we redefine something previously added */
+						//assert(0);
 					}
-					currentPlayList = playlist_element_new(
+					curr_playlist = playlist_element_new(
 					                      TYPE_UNKNOWN,
 					                      fullURL,
 					                      attribs.title,
 					                      attribs.codecs,
-					                      attribs.durationInSeconds,
-					                      attribs.byteRangeStart, attribs.byteRangeEnd);
-					if (currentPlayList == NULL) {
+					                      attribs.duration_in_seconds,
+					                      attribs.byte_range_start, attribs.byte_range_end);
+					if (curr_playlist == NULL) {
 						/* OUT of memory */
-						variant_playlist_del(*playlist);
+						gf_m3u8_variant_playlist_del(*playlist);
 						playlist = NULL;
 						if (f) fclose(f);
 						return GF_OUT_OF_MEM;
 					}
-					assert( fullURL);
-					currentPlayList->url = gf_strdup(fullURL);
-					currentPlayList->title = attribs.title ? gf_strdup(attribs.title):NULL;
-					currentPlayList->codecs = attribs.codecs ? gf_strdup(attribs.codecs):NULL;
-					gf_list_add(program->bitrates, currentPlayList);
-					currentPlayList->width = attribs.width;
-					currentPlayList->height = attribs.height;
+					assert(fullURL);
+					curr_playlist->url = gf_strdup(fullURL);
+					curr_playlist->title = attribs.title ? gf_strdup(attribs.title):NULL;
+					curr_playlist->codecs = attribs.codecs ? gf_strdup(attribs.codecs):NULL;
+					gf_list_add(program->variants, curr_playlist);
+					curr_playlist->width = attribs.width;
+					curr_playlist->height = attribs.height;
 				} else {
 					/* Normal Playlist */
-					assert( pl->programs);
-					if (currentPlayList == NULL) {
-						/* This is in facts a "normal" playlist without any element in it */
-						PlaylistElement * subElement;
+					assert(pl->streams);
+					if (curr_playlist == NULL) {
+						/* This is a "normal" playlist without any element in it */
+						PlaylistElement *subElement;
 						assert(baseURL);
-						currentPlayList = playlist_element_new(
+						curr_playlist = playlist_element_new(
 						                      TYPE_PLAYLIST,
 						                      baseURL,
 						                      attribs.title,
 						                      attribs.codecs,
-						                      attribs.durationInSeconds,
-						                      attribs.byteRangeStart, attribs.byteRangeEnd);
-						if (currentPlayList == NULL) {
+						                      attribs.duration_in_seconds,
+						                      attribs.byte_range_start, attribs.byte_range_end);
+						if (curr_playlist == NULL) {
 							/* OUT of memory */
-							variant_playlist_del(*playlist);
+							gf_m3u8_variant_playlist_del(*playlist);
 							playlist = NULL;
 							if (f) fclose(f);
 							return GF_OUT_OF_MEM;
 						}
-						assert(currentPlayList->element.playlist.elements);
-						assert( fullURL);
-						assert( currentPlayList->url);
-						currentPlayList->title = NULL;
-						currentPlayList->codecs = NULL;
+						assert(curr_playlist->element.playlist.elements);
+						assert(fullURL);
+						assert(curr_playlist->url);
+						curr_playlist->title = NULL;
+						curr_playlist->codecs = NULL;
 						subElement = playlist_element_new(
 						                 TYPE_UNKNOWN,
 						                 fullURL,
 						                 attribs.title,
 						                 attribs.codecs,
-						                 attribs.durationInSeconds,
-						                 attribs.byteRangeStart, attribs.byteRangeEnd);
+						                 attribs.duration_in_seconds,
+						                 attribs.byte_range_start, attribs.byte_range_end);
 						if (subElement == NULL) {
-							variant_playlist_del(*playlist);
-							playlist_element_del(currentPlayList);
+							gf_m3u8_variant_playlist_del(*playlist);
+							playlist_element_del(curr_playlist);
 							playlist = NULL;
 							if (f) fclose(f);
 							return GF_OUT_OF_MEM;
 						}
-						gf_list_add(currentPlayList->element.playlist.elements, subElement);
-						gf_list_add(program->bitrates, currentPlayList);
-						currentPlayList->element.playlist.computed_duration += subElement->durationInfo;
-						assert( program );
-						assert( program->bitrates);
-						assert( currentPlayList);
+						gf_list_add(curr_playlist->element.playlist.elements, subElement);
+						gf_list_add(program->variants, curr_playlist);
+						curr_playlist->element.playlist.computed_duration += subElement->duration_info;
+						assert(program);
+						assert(program->variants);
+						assert(curr_playlist);
 
 					} else {
-						PlaylistElement * subElement = playlist_element_new(
+						PlaylistElement *subElement = playlist_element_new(
 						                                   TYPE_UNKNOWN,
 						                                   fullURL,
 						                                   attribs.title,
 						                                   attribs.codecs,
-						                                   attribs.durationInSeconds,
-						                                   attribs.byteRangeStart, attribs.byteRangeEnd);
-						if (currentPlayList->elementType != TYPE_PLAYLIST) {
-							currentPlayList->elementType = TYPE_PLAYLIST;
-							if (!currentPlayList->element.playlist.elements)
-								currentPlayList->element.playlist.elements = gf_list_new();
+						                                   attribs.duration_in_seconds,
+						                                   attribs.byte_range_start, attribs.byte_range_end);
+						if (curr_playlist->element_type != TYPE_PLAYLIST) {
+							curr_playlist->element_type = TYPE_PLAYLIST;
+							if (!curr_playlist->element.playlist.elements)
+								curr_playlist->element.playlist.elements = gf_list_new();
 						}
 						if (subElement == NULL) {
-							variant_playlist_del(*playlist);
-							playlist_element_del(currentPlayList);
+							gf_m3u8_variant_playlist_del(*playlist);
+							playlist_element_del(curr_playlist);
 							playlist = NULL;
 							if (f) fclose(f);
 							return GF_OUT_OF_MEM;
 						}
-						gf_list_add(currentPlayList->element.playlist.elements, subElement);
-						currentPlayList->element.playlist.computed_duration += subElement->durationInfo;
+						gf_list_add(curr_playlist->element.playlist.elements, subElement);
+						curr_playlist->element.playlist.computed_duration += subElement->duration_info;
 					}
 				}
 
-				currentPlayList->element.playlist.currentMediaSequence = attribs.currentMediaSequence ;
+				curr_playlist->element.playlist.current_media_seq = attribs.current_media_seq;
 				/* We first set the default duration for element, aka targetDuration */
-				if (attribs.targetDurationInSeconds > 0) {
-					currentPlayList->element.playlist.target_duration = attribs.targetDurationInSeconds;
-					currentPlayList->durationInfo = attribs.targetDurationInSeconds;
+				if (attribs.target_duration_in_seconds > 0) {
+					curr_playlist->element.playlist.target_duration = attribs.target_duration_in_seconds;
+					curr_playlist->duration_info = attribs.target_duration_in_seconds;
 				}
-				if (attribs.durationInSeconds) {
-					if (currentPlayList->durationInfo == 0) {
+				if (attribs.duration_in_seconds) {
+					if (curr_playlist->duration_info == 0) {
 						/* we set the playlist duration info as the duration of a segment, only if it's not set
 						   There are cases of playlist with the last segment with a duration different from the others
 						   (example: Apple bipbop test)*/
-						currentPlayList->durationInfo = attribs.durationInSeconds;
+						curr_playlist->duration_info = attribs.duration_in_seconds;
 					}
 				}
-				currentPlayList->element.playlist.mediaSequenceMin = attribs.minMediaSequence;
-				currentPlayList->element.playlist.mediaSequenceMax = attribs.currentMediaSequence++;
+				curr_playlist->element.playlist.media_seq_min = attribs.min_media_sequence;
+				curr_playlist->element.playlist.media_seq_max = attribs.current_media_seq++;
 				if (attribs.bandwidth > 1)
-					currentPlayList->bandwidth = attribs.bandwidth;
-				if (attribs.isPlaylistEnded)
-					currentPlayList->element.playlist.is_ended = 1;
+					curr_playlist->bandwidth = attribs.bandwidth;
+				if (attribs.is_playlist_ended)
+					curr_playlist->element.playlist.is_ended = GF_TRUE;
 			}
 			/* Cleanup all line-specific fields */
 			if (attribs.title) {
 				gf_free(attribs.title);
 				attribs.title = NULL;
 			}
-			attribs.durationInSeconds = 0;
+			attribs.duration_in_seconds = 0;
 			attribs.bandwidth = 0;
-			attribs.programId = 0;
+			attribs.program_id = 0;
 			if (attribs.codecs != NULL) {
 				gf_free(attribs.codecs);
 				attribs.codecs = NULL;
@@ -794,13 +741,13 @@ GF_Err parse_sub_playlist(const char * file, VariantPlaylist ** playlist, const
 	}
 	if (f) fclose(f);
 
-	for (i=0; i < (int) gf_list_count(pl->programs); i++) {
+	for (i=0; i<(int)gf_list_count(pl->streams); i++) {
 		u32 j;
-		Program *prog = gf_list_get(pl->programs, i);
+		Stream *prog = gf_list_get(pl->streams, i);
 		prog->computed_duration = 0;
-		for (j=0; j<gf_list_count(prog->bitrates); j++) {
-			PlaylistElement *ple = gf_list_get(prog->bitrates, j);
-			if (ple->elementType==TYPE_PLAYLIST) {
+		for (j=0; j<gf_list_count(prog->variants); j++) {
+			PlaylistElement *ple = gf_list_get(prog->variants, j);
+			if (ple->element_type == TYPE_PLAYLIST) {
 				if (ple->element.playlist.computed_duration > prog->computed_duration)
 					prog->computed_duration = ple->element.playlist.computed_duration;
 			}
diff --git a/src/media_tools/media_import.c b/src/media_tools/media_import.c
index 2c7240fa29..e9093600b0 100644
--- a/src/media_tools/media_import.c
+++ b/src/media_tools/media_import.c
@@ -181,10 +181,12 @@ static GF_Err gf_import_still_image(GF_MediaImporter *import, Bool mult_desc_all
 	u8 OTI;
 	char *dsi, *data;
 	FILE *src;
-	Bool import_mpeg4 = 0;
+	Bool import_mpeg4 = GF_FALSE;
 
-	if (import->flags & GF_IMPORT_FORCE_MPEG4) import_mpeg4 = 1;
-	else if (import->esd)  import_mpeg4 = 1;
+	if (import->flags & GF_IMPORT_FORCE_MPEG4)
+		import_mpeg4 = GF_TRUE;
+	else if (import->esd)
+		import_mpeg4 = GF_TRUE;
 
 	src = gf_f64_open(import->in_name, "rb");
 	if (!src) return gf_import_message(import, GF_URL_ERROR, "Opening file %s failed", import->in_name);
@@ -455,7 +457,7 @@ GF_Err gf_import_mp3(GF_MediaImporter *import)
 	GF_Err e;
 	u16 sr;
 	u32 nb_chan;
-	Bool force_mpeg4 = 0;
+	Bool force_mpeg4 = GF_FALSE;
 	FILE *in;
 	u32 hdr, size, max_size, track, di;
 	u64 done, tot_size, offset, duration;
@@ -697,7 +699,7 @@ static Bool LOAS_LoadFrame(GF_BitStream *bs, GF_M4ADecSpecInfo *acfg, u32 *nb_by
 					num_lay = gf_bs_read_int(bs, 3);
 					for (j=0; j<=num_lay; j++) {
 						u32 frameLengthType;
-						Bool same_cfg = 0;
+						Bool same_cfg = GF_FALSE;
 						if (i || j) same_cfg = gf_bs_read_int(bs, 1);
 
 						if (!same_cfg) {
@@ -3477,11 +3479,11 @@ GF_Err gf_import_nhml_dims(GF_MediaImporter *import, Bool dims_doc)
 			e = gf_xml_parse_bit_sequence(node, &samp->data, &samp->dataLength);
 			max_size = samp->dataLength;
 		} else {
-			Bool close = 0;
+			Bool close = GF_FALSE;
 			FILE *f = mdia;
 			if (strlen(szMediaTemp)) {
 				f = gf_f64_open(szMediaTemp, "rb");
-				close = 1;
+				close = GF_TRUE;
 				if (offset) gf_f64_seek(f, offset, SEEK_SET);
 			} else {
 				if (!offset) offset = media_done;
@@ -5455,16 +5457,16 @@ static GF_Err gf_import_hevc(GF_MediaImporter *import)
 	last_poc = max_last_poc = max_last_b_poc = prev_last_poc = 0;
 	max_total_delay = 0;
 
-	gf_isom_set_cts_packing(import->dest, track, 1);
-	has_cts_offset = 0;
+	gf_isom_set_cts_packing(import->dest, track, GF_TRUE);
+	has_cts_offset = GF_FALSE;
 	min_poc = 0;
 	poc_shift = 0;
-	flush_next_sample = 0;
-	is_empty_sample = 1;
+	flush_next_sample = GF_FALSE;
+	is_empty_sample = GF_TRUE;
 
 	while (gf_bs_available(bs)) {
 		s32 res;
-		Bool force_shvc = 0;
+		Bool force_shvc = GF_FALSE;
 		GF_HEVCConfig *prev_cfg;
 		u8 nal_unit_type, temporal_id, layer_id;
 		Bool skip_nal, add_sps, is_slice, has_vcl_nal;
@@ -6824,7 +6826,7 @@ GF_Err gf_import_saf(GF_MediaImporter *import)
 		if (!stream_id) stream_id = 1000;
 
 		if ((type==1) || (type==2) || (type==7)) {
-			Bool in_root_od = 0;
+			Bool in_root_od = GF_FALSE;
 			u32 mtype, stype;
 			char *name = "Unknown";
 
@@ -6922,10 +6924,10 @@ GF_Err gf_import_saf(GF_MediaImporter *import)
 					import->nb_tracks++;
 				}
 			} else if ((stream_id==import->trackID) && !track) {
-				Bool delete_esd = 0;
+				Bool delete_esd = GF_FALSE;
 				if (!import->esd) {
 					import->esd = gf_odf_desc_esd_new(0);
-					delete_esd = 1;
+					delete_esd = GF_TRUE;
 					if (import->esd->URLString) gf_free(import->esd->URLString);
 					import->esd->URLString = NULL;
 				}
@@ -7143,7 +7145,7 @@ static void m2ts_create_track(GF_TSImport *tsimp, u32 mtype, u32 stype, u32 oti,
 	GF_MediaImporter *import= (GF_MediaImporter *)tsimp->import;
 	if (mtype != GF_ISOM_MEDIA_ESM) {
 		u32 di;
-		Bool destroy_esd = 0;
+		Bool destroy_esd = GF_FALSE;
 		if (import->esd) mpeg4_es_id = import->esd->ESID;
 		else if (!mpeg4_es_id) mpeg4_es_id = import->trackID;
 
@@ -7637,26 +7639,26 @@ void on_m2ts_import_data(GF_M2TS_Demuxer *ts, u32 evt_type, void *par)
 		if (tsimp->avccfg && !pck->data[0] && !pck->data[1]) {
 			GF_AVCConfigSlot *slc;
 			s32 idx;
-			Bool add_sps, is_subseq = 0;
+			Bool add_sps, is_subseq = GF_FALSE;
 			u32 nal_type = pck->data[4] & 0x1F;
 
 			switch (nal_type) {
 			case GF_AVC_NALU_SVC_SUBSEQ_PARAM:
-				is_subseq = 1;
+				is_subseq = GF_TRUE;
 			case GF_AVC_NALU_SEQ_PARAM:
 				idx = gf_media_avc_read_sps(pck->data+4, pck->data_len-4, &tsimp->avc, is_subseq, NULL);
 
-				add_sps = 0;
+				add_sps = GF_FALSE;
 				if (idx>=0) {
 					if (is_subseq) {
 						if ((tsimp->avc.sps[idx].state & AVC_SUBSPS_PARSED) && !(tsimp->avc.sps[idx].state & AVC_SUBSPS_DECLARED)) {
 							tsimp->avc.sps[idx].state |= AVC_SUBSPS_DECLARED;
-							add_sps = 1;
+							add_sps = GF_TRUE;
 						}
 					} else {
 						if ((tsimp->avc.sps[idx].state & AVC_SPS_PARSED) && !(tsimp->avc.sps[idx].state & AVC_SPS_DECLARED)) {
 							tsimp->avc.sps[idx].state |= AVC_SPS_DECLARED;
-							add_sps = 1;
+							add_sps = GF_TRUE;
 						}
 					}
 					if (add_sps) {
@@ -7693,7 +7695,7 @@ void on_m2ts_import_data(GF_M2TS_Demuxer *ts, u32 evt_type, void *par)
 				return;
 			/*remove*/
 			case GF_AVC_NALU_ACCESS_UNIT:
-				tsimp->force_next_au_start = 1;
+				tsimp->force_next_au_start = GF_TRUE;
 				return;
 			case GF_AVC_NALU_FILLER_DATA:
 			case GF_AVC_NALU_END_OF_SEQ:
@@ -7709,8 +7711,8 @@ void on_m2ts_import_data(GF_M2TS_Demuxer *ts, u32 evt_type, void *par)
 			}
 
 			if (tsimp->force_next_au_start) {
-				is_au_start = 1;
-				tsimp->force_next_au_start = 0;
+				is_au_start = GF_TRUE;
+				tsimp->force_next_au_start = GF_FALSE;
 			}
 		}
 
@@ -7719,7 +7721,7 @@ void on_m2ts_import_data(GF_M2TS_Demuxer *ts, u32 evt_type, void *par)
 #ifndef GPAC_DISABLE_HEVC
 		else if (tsimp->hevccfg && !pck->data[0] && !pck->data[1]) {
 			s32 idx;
-			Bool add_sps, is_subseq = 0;
+			Bool add_sps, is_subseq = GF_FALSE;
 			u32 nal_type = (pck->data[4] & 0x7E) >> 1;
 
 			switch (nal_type) {
@@ -8071,7 +8073,7 @@ GF_Err gf_import_mpeg_ts(GF_MediaImporter *import)
 	GF_TSImport tsimp;
 	u64 fsize, done;
 	u32 size, i;
-	Bool do_import = 1;
+	Bool do_import = GF_TRUE;
 	FILE *mts;
 	char progress[1000];
 
@@ -8222,7 +8224,7 @@ GF_Err gf_import_vobsub(GF_MediaImporter *import)
 	int		  version;
 	vobsub_file	  *vobsub = NULL;
 	u32		  c, trackID, track, di;
-	Bool		  destroy_esd = 0;
+	Bool		  destroy_esd = GF_FALSE;
 	GF_Err		  err = GF_OK;
 	GF_ISOSample	 *samp = NULL;
 	GF_List		 *subpic;
@@ -8658,7 +8660,7 @@ GF_Err gf_media_import_chapters_file(GF_MediaImporter *import)
 	gf_f64_seek(f, offset, SEEK_SET);
 
 	if (import->flags & GF_IMPORT_PROBE_ONLY) {
-		Bool is_chap_or_sub = 0;
+		Bool is_chap_or_sub = GF_FALSE;
 		import->nb_tracks = 0;
 		while (!is_chap_or_sub && (fgets(line, 1024, f) != NULL)) {
 			char *sep;
diff --git a/src/media_tools/mpd.c b/src/media_tools/mpd.c
index 51d8d29f62..9a28d48c6d 100644
--- a/src/media_tools/mpd.c
+++ b/src/media_tools/mpd.c
@@ -51,7 +51,7 @@ static Bool gf_mpd_valid_child(GF_MPD *mpd, GF_XMLNode *child)
 {
 	if (child->type != GF_XML_NODE_TYPE) return 0;
 	if (!mpd->xml_namespace && !child->ns) return 1;
-	if (mpd->xml_namespace && child->ns && !strcmp(mpd->xml_namespace, child->ns) ) return 1;
+	if (mpd->xml_namespace && child->ns && !strcmp(mpd->xml_namespace, child->ns)) return 1;
 	return 0;
 }
 
@@ -764,9 +764,8 @@ void gf_mpd_url_free(void *_item)
 	if (ptr->sourceURL) gf_free(ptr->sourceURL);
 	gf_free(ptr);
 }
-void gf_mpd_string_free(void *_item)
-{
-	gf_free( (char *) _item );
+void gf_mpd_string_free(void *_item) {
+	gf_free(_item);
 }
 
 void gf_mpd_prog_info_free(void *_item)
@@ -962,7 +961,7 @@ GF_Err gf_mpd_complete_from_dom(GF_XMLNode *root, GF_MPD *mpd, const char *defau
 {
 	GF_Err e;
 	u32 i;
-	Bool ns_ok = 0;
+	Bool ns_ok = GF_FALSE;
 	GF_XMLAttribute *att;
 	GF_XMLNode *child;
 
@@ -1030,7 +1029,7 @@ GF_Err gf_mpd_complete_from_dom(GF_XMLNode *root, GF_MPD *mpd, const char *defau
 
 	i = 0;
 	while ( ( child = gf_list_enum(root->content, &i )) ) {
-		if (! gf_mpd_valid_child(mpd, child) ) 
+		if (! gf_mpd_valid_child(mpd, child)) 
 			continue;
 
 		if (!strcmp(child->name, "ProgramInformation")) {
@@ -1061,17 +1060,16 @@ GF_Err gf_mpd_init_from_dom(GF_XMLNode *root, GF_MPD *mpd, const char *default_b
 {
 	if (!root || !mpd) return GF_BAD_PARAM;
 
-	assert( !mpd->periods );
+	assert(!mpd->periods);
 	mpd->periods = gf_list_new();
 	mpd->program_infos = gf_list_new();
 	mpd->base_URLs = gf_list_new();
 	mpd->locations = gf_list_new();
 	mpd->metrics = gf_list_new();
+
 	/*setup some defaults*/
 	mpd->type = GF_MPD_TYPE_STATIC;
-	/*infinite by default*/
-	mpd->time_shift_buffer_depth = (u32) -1;
-
+	mpd->time_shift_buffer_depth = (u32) -1; /*infinite by default*/
 	mpd->xml_namespace = NULL;
 
 	return gf_mpd_complete_from_dom(root, mpd, default_base_url);
@@ -1084,11 +1082,11 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 {
 	GF_Err e;
 	char *sep, *template_base, *template_ext;
-	u32 i, count, j, count2, k, count3, template_width, template_idx_start;
+	u32 i, count, j, k, template_width, template_idx_start;
 	Double update_interval;
-	VariantPlaylist * pl = NULL;
+	MasterPlaylist *pl = NULL;
 	Bool use_template;
-	Program *prog;
+	Stream *prog;
 	PlaylistElement *pe, *the_pe, *elt;
 	FILE *fmpd;
 	Bool is_end;
@@ -1097,7 +1095,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	e = gf_m3u8_parse_master_playlist(m3u8_file, &pl, base_url);
 	if (e) {
 		GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("[M3U8] Failed to parse root playlist '%s', error = %s\n", m3u8_file, gf_error_to_string(e)));
-		if (pl) variant_playlist_del(pl);
+		if (pl) gf_m3u8_variant_playlist_del(pl);
 		pl = NULL;
 		return e;
 	}
@@ -1105,55 +1103,53 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 		gf_delete_file(m3u8_file);
 		mpd_file = m3u8_file;
 	}
+
 	the_pe = NULL;
 	pe = NULL;
-	i=0;
-	assert( pl );
-	assert( pl->programs );
-	while ((prog = gf_list_enum(pl->programs, &i))) {
-		u32 j=0;
-
-		while (NULL != (pe = gf_list_enum(prog->bitrates, &j))) {
-			Bool found = 0;
-			u32 k;
+	i = 0, j = 0, k = 0;
+	assert(pl);
+	assert(pl->streams);
+	while ((prog = gf_list_enum(pl->streams, &i))) {
+		while (NULL != (pe = gf_list_enum(prog->variants, &j))) {
+			Bool found = GF_FALSE;
 			char *suburl;
-
-			if (!pe->url )
+			if (!pe->url)
 				continue;
 
-			/*filter out duplicated entries (seen on M6 m3u8)*/
-			for (k=0; k<j-1; k++) {
-				PlaylistElement *a_pe = gf_list_get(prog->bitrates, k);
+			/* filter out duplicated entries (seen on M6 m3u8) */
+			for (k=0; k<j-1; ++k) {
+				PlaylistElement *a_pe = gf_list_get(prog->variants, k);
 				if (a_pe->url && pe->url && !strcmp(a_pe->url, pe->url)) {
-					found = 1;
+					found = GF_TRUE;
 					break;
 				}
 			}
-			if (found) continue;
+			if (found)
+				continue;
 
 			the_pe = pe;
 			suburl = NULL;
-
-			/*not HLS*/
-			if ( !strstr(pe->url, ".m3u8"))
-				continue;
+			if (!strstr(pe->url, ".m3u8"))
+				continue; /*not HLS*/
 
 			if (strcmp(base_url, pe->url))
 				suburl = gf_url_concatenate(base_url, pe->url);
 
 			if (!suburl || !strcmp(base_url, suburl)) {
-				if (suburl) gf_free(suburl);
+				if (suburl)
+					gf_free(suburl);
 				GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] Not downloading, programs are identical for %s...\n", pe->url));
 				continue;
 			}
+
 			if (getter && getter->new_session && getter->del_session && getter->get_cache_name) {
 				e = getter->new_session(getter, suburl);
 				if (e) {
 					gf_free(suburl);
 					break;
 				}
-				if (e==GF_OK) {
-					e = parse_sub_playlist(getter->get_cache_name(getter), &pl, suburl, prog, pe);
+				if (e == GF_OK) {
+					e = gf_m3u8_parse_sub_playlist(getter->get_cache_name(getter), &pl, suburl, prog, pe);
 				}
 				getter->del_session(getter);
 
@@ -1165,78 +1161,85 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				}
 				e = gf_dm_sess_process(sess);
 				if (e==GF_OK) {
-					e = parse_sub_playlist(gf_dm_sess_get_cache_name(sess), &pl, suburl, prog, pe);
+					e = gf_m3u8_parse_sub_playlist(gf_dm_sess_get_cache_name(sess), &pl, suburl, prog, pe);
 				}
 				gf_service_download_del(sess);
 #endif
 				gf_free(suburl);
 			} else { /* for use in MP4Box */
-				if (strstr(suburl, "://") ) {
+				if (strstr(suburl, "://")) {
 					e = gf_dm_wget(suburl, "tmp.m3u8", 0, 0);
-					if (e==GF_OK) {
-						e = parse_sub_playlist("tmp.m3u8", &pl, suburl, prog, pe);
+					if (e == GF_OK) {
+						e = gf_m3u8_parse_sub_playlist("tmp.m3u8", &pl, suburl, prog, pe);
 					}
 					gf_delete_file("tmp.m3u8");
 				} else {
-					e = parse_sub_playlist(suburl, &pl, suburl, prog, pe);
+					e = gf_m3u8_parse_sub_playlist(suburl, &pl, suburl, prog, pe);
 				}
 			}
 		}
-		if (max_dur < (u32) prog->computed_duration)
+		if (max_dur < (u32) prog->computed_duration) {
 			max_dur = (u32) prog->computed_duration;
+		}
 	}
 
-	is_end = !pl->playlistNeedsRefresh;
+	is_end = !pl->playlist_needs_refresh;
 	assert(the_pe);
 
 	update_interval = 0;
 	/*update interval is set to the duration of the last media file with rules defined in http live streaming RFC section 6.3.4*/
 	switch (reload_count) {
 	case 0:
-		update_interval = the_pe->durationInfo;
+		update_interval = the_pe->duration_info;
 		break;
 	case 1:
-		update_interval = (Double)the_pe->durationInfo/2;
+		update_interval = (Double)the_pe->duration_info / 2;
 		break;
 	case 2:
-		update_interval = 3*((Double)the_pe->durationInfo/2);
+		update_interval = 3 * ((Double)the_pe->duration_info / 2);
 		break;
 	default:
-		update_interval = 3*(the_pe->durationInfo);
+		update_interval = 3 * the_pe->duration_info;
 		break;
 	}
-	if (is_end || ((the_pe->elementType == TYPE_PLAYLIST) && the_pe->element.playlist.is_ended)) {
+	if (is_end || ((the_pe->element_type == TYPE_PLAYLIST) && the_pe->element.playlist.is_ended)) {
 		update_interval = 0;
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] NO NEED to refresh playlist !\n"));
+		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] No need to refresh playlist!\n"));
 	} else {
-		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] Playlist will be refreshed every %g seconds, len=%d\n", update_interval, the_pe->durationInfo));
+		GF_LOG(GF_LOG_DEBUG, GF_LOG_DASH, ("[MPD Generator] Playlist will be refreshed every %g seconds, len=%d\n", update_interval, the_pe->duration_info));
 	}
 
-	assert( mpd_file );
+	assert(mpd_file);
 	fmpd = gf_f64_open(mpd_file, "wt");
 	if (!fmpd) {
 		GF_LOG(GF_LOG_ERROR, GF_LOG_DASH, ("[MPD Generator] Cannot write to temp file %s!\n", mpd_file));
-		variant_playlist_del(pl);
+		gf_m3u8_variant_playlist_del(pl);
 		return GF_IO_ERR;
 	}
+
 	fprintf(fmpd, "<MPD type=\"%s\" xmlns=\"urn:mpeg:DASH:schema:MPD:2011\" profiles=\"urn:mpeg:dash:profile:full:2011\"", is_end ? "static" : "dynamic" );
 	sep = strrchr(m3u8_file, '/');
-	if (!sep) sep = strrchr(m3u8_file, '\\');
-	if (sep) sep = sep + 1;
-	else sep = (char *)m3u8_file;
+	if (!sep)
+		sep = strrchr(m3u8_file, '\\');
+	if (sep)
+		sep = sep + 1;
+	else
+		sep = (char *)m3u8_file;
 	fprintf(fmpd, " id=\"%s\"", sep);
 
-	if (update_interval) fprintf(fmpd, " minimumUpdatePeriod=\"PT%02.2gS\"", update_interval);
-	if (is_end) fprintf(fmpd, " mediaPresentationDuration=\"PT%dS\"", max_dur);
+	if (update_interval)
+		fprintf(fmpd, " minimumUpdatePeriod=\"PT%02.2gS\"", update_interval);
+	if (is_end)
+		fprintf(fmpd, " mediaPresentationDuration=\"PT%dS\"", max_dur);
 	fprintf(fmpd, " minBufferTime=\"PT1.5S\"");
 	fprintf(fmpd, ">\n");
 
 	fprintf(fmpd, " <ProgramInformation moreInformationURL=\"http://gpac.sourceforge.net\">\n");
 	{
-		char * title = the_pe->title;
+		char *title = the_pe->title;
 		if (!title || strlen(title) < 2)
 			title = the_pe->url;
-		fprintf(fmpd, "  <Title>%s</Title>\n", title );
+		fprintf(fmpd, "  <Title>%s</Title>\n", title);
 	}
 	fprintf(fmpd, "  <Source>Generated from URL %s</Source>\n", base_url );
 	fprintf(fmpd, "  <Copyright>Generated by GPAC %s from %s</Copyright>\n", GPAC_FULL_VERSION, base_url);
@@ -1245,9 +1248,8 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	fprintf(fmpd, " <Period start=\"PT0S\"");
 	if (is_end) fprintf(fmpd, " duration=\"PT%dS\"", max_dur);
 	fprintf(fmpd, " >\n");
-
-
-	count = gf_list_count(pl->programs);
+	
+	count = gf_list_count(pl->streams);
 	/*check if we use templates*/
 	template_base = NULL;
 	template_ext = NULL;
@@ -1255,15 +1257,18 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	template_width = 0;
 	template_idx_start = 0;
 	for (i=0; i<count; i++) {
-		prog = gf_list_get(pl->programs, i);
-		count2 = gf_list_count(prog->bitrates);
-		for (j = 0; j<count2; j++) {
-			pe = gf_list_get(prog->bitrates, j);
-			if (pe->elementType != TYPE_PLAYLIST)
+		u32 count_variants;
+		prog = gf_list_get(pl->streams, i);
+		count_variants = gf_list_count(prog->variants);
+		for (j=0; j<count_variants; j++) {
+			u32 count_elements;
+			pe = gf_list_get(prog->variants, j);
+			if (pe->element_type != TYPE_PLAYLIST)
 				continue;
 
-			count3 = gf_list_count(pe->element.playlist.elements);
-			if (!count3) continue;
+			count_elements = gf_list_count(pe->element.playlist.elements);
+			if (!count_elements)
+				continue;
 
 			if (!template_base && use_template) {
 				char *sub_url;
@@ -1290,7 +1295,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 					}
 					k++;
 					if (!template_base[k]) {
-						use_template = 0;
+						use_template = GF_FALSE;
 						break;
 					}
 				}
@@ -1298,22 +1303,28 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 			if (!template_ext) template_ext="";
 
 			if (use_template) {
-				for (k=0; k<count3; k++) {
+				for (k=0; k<count_elements; k++) {
 					char szURL[GF_MAX_PATH], *sub_url;
 					elt = gf_list_get(pe->element.playlist.elements, k);
 
-					if (template_width==2) sprintf(szURL, "%s%02d%s", template_base, template_idx_start + k, template_ext);
-					else if (template_width==3) sprintf(szURL, "%s%03d%s", template_base, template_idx_start + k, template_ext);
-					else if (template_width==4) sprintf(szURL, "%s%04d%s", template_base, template_idx_start + k, template_ext);
-					else if (template_width==5) sprintf(szURL, "%s%05d%s", template_base, template_idx_start + k, template_ext);
-					else if (template_width==6) sprintf(szURL, "%s%06d%s", template_base, template_idx_start + k, template_ext);
-					else sprintf(szURL, "%s%d%s", template_base, template_idx_start + k, template_ext);
+					if (template_width == 2)
+						sprintf(szURL, "%s%02d%s", template_base, template_idx_start + k, template_ext);
+					else if (template_width == 3)
+						sprintf(szURL, "%s%03d%s", template_base, template_idx_start + k, template_ext);
+					else if (template_width == 4)
+						sprintf(szURL, "%s%04d%s", template_base, template_idx_start + k, template_ext);
+					else if (template_width == 5)
+						sprintf(szURL, "%s%05d%s", template_base, template_idx_start + k, template_ext);
+					else if (template_width == 6)
+						sprintf(szURL, "%s%06d%s", template_base, template_idx_start + k, template_ext);
+					else
+						sprintf(szURL, "%s%d%s", template_base, template_idx_start + k, template_ext);
 
 					sub_url = strrchr(elt->url, '/');
 					if (!sub_url) sub_url = elt->url;
 					else sub_url ++;
 					if (strcmp(szURL, sub_url)) {
-						use_template = 0;
+						use_template = GF_FALSE;
 						break;
 					}
 				}
@@ -1328,8 +1339,8 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	if (use_template) {
 		fprintf(fmpd, "   <SegmentTemplate");
 
-		fprintf(fmpd, " duration=\"%d\"", pe->durationInfo);
-		if (template_width>1) {
+		fprintf(fmpd, " duration=\"%d\"", pe->duration_info);
+		if (template_width > 1) {
 			fprintf(fmpd, " media=\"%s$%%0%ddNumber$%s\"", template_base, template_width, template_ext);
 		} else {
 			fprintf(fmpd, " media=\"%s$Number$%s\"", template_base, template_ext);
@@ -1363,7 +1374,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 			e = gf_media_import(&import);
 		}
 
-		if (import.nb_tracks>1) {
+		if (import.nb_tracks > 1) {
 			for (k=0; k<import.nb_tracks; k++) {
 				fprintf(fmpd, "   <ContentComponent id=\"%d\"", import.tk_info[k].track_num);
 				if (import.tk_info[k].lang)
@@ -1388,28 +1399,31 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	}
 
 	/*check if we use templates*/
-	count = gf_list_count(pl->programs);
+	count = gf_list_count(pl->streams);
 	for (i=0; i<count; i++) {
+		u32 count_variants;
 		u32 width, height, samplerate, num_channels;
-		prog = gf_list_get(pl->programs, i);
-		count2 = gf_list_count(prog->bitrates);
-		for (j = 0; j<count2; j++) {
+		prog = gf_list_get(pl->streams, i);
+		count_variants = gf_list_count(prog->variants);
+		for (j = 0; j<count_variants; j++) {
 			char *base_url;
+			u32 count_elements;
 #ifndef GPAC_DISABLE_MEDIA_IMPORT
 			Bool import_file = do_import;
 #endif
-			Bool is_aac = 0;
+			Bool is_aac = GF_FALSE;
 			char *byte_range_media_file = NULL;
-			pe = gf_list_get(prog->bitrates, j);
+			pe = gf_list_get(prog->variants, j);
 
-			if (pe->elementType == TYPE_STREAM) {
-				GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD] NOT SUPPORTED: M3U8 Stream\n"));
-			} else if (pe->elementType != TYPE_PLAYLIST) {
+			if (pe->element_type == TYPE_MEDIA) {
+				GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD] NOT SUPPORTED: M3U8 Media\n"));
+			} else if (pe->element_type != TYPE_PLAYLIST) {
 				GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD] NOT SUPPORTED: M3U8 unknown type\n"));
 			}
 
-			count3 = gf_list_count(pe->element.playlist.elements);
-			if (!count3) continue;
+			count_elements = gf_list_count(pe->element.playlist.elements);
+			if (!count_elements)
+				continue;
 
 			base_url = gf_strdup(pe->url);
 			sep = strrchr(base_url, '/');
@@ -1421,14 +1435,14 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 			}
 #ifndef GPAC_DISABLE_MEDIA_IMPORT
 			if (pe->bandwidth && pe->codecs && pe->width && pe->height) {
-				import_file = 0;
+				import_file = GF_FALSE;
 			}
 #endif
 
 			/*get rid of level 0 aac*/
 			elt = gf_list_get(pe->element.playlist.elements, 0);
 			if (elt && strstr(elt->url, ".aac"))
-				is_aac = 1;
+				is_aac = GF_TRUE;
 
 			if (is_aac)
 				fprintf(fmpd, "<!-- \n");
@@ -1448,11 +1462,12 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 
 				if (strstr(elt->url, "://") && !strstr(elt->url, "file://")) {
 					tmp_file = strrchr(elt->url, '/');
-					if (!tmp_file) tmp_file = strrchr(elt->url, '\\');
+					if (!tmp_file)
+						tmp_file = strrchr(elt->url, '\\');
 					if (tmp_file) {
 						tmp_file++;
-						e = gf_dm_wget(elt->url, tmp_file, elt->byteRangeStart, elt->byteRangeEnd);
-						if (e==GF_OK) {
+						e = gf_dm_wget(elt->url, tmp_file, elt->byte_range_start, elt->byte_range_end);
+						if (e == GF_OK) {
 							import.in_name = tmp_file;
 						}
 					}
@@ -1461,7 +1476,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				}
 				e = gf_media_import(&import);
 
-				if (!pe->bandwidth && pe->durationInfo) {
+				if (!pe->bandwidth && pe->duration_info) {
 					u64 pos = 0;
 					Double bw;
 					FILE *t = gf_f64_open(import.in_name, "rb");
@@ -1472,7 +1487,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 					}
 					bw = (Double) pos;
 					bw *= 8;
-					bw /= pe->durationInfo;
+					bw /= pe->duration_info;
 					pe->bandwidth = (u32) bw;
 				}
 
@@ -1502,14 +1517,14 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 						break;
 					}
 				}
-
 			}
 #endif
 
 			fprintf(fmpd, "   <Representation id=\"%s\" bandwidth=\"%d\"", sep ? sep+1 : base_url, pe->bandwidth);
-			/* SOUCHAY : if mime-type is still unknown, do not try to add codec information since it would be wrong */
-			if (!strcmp(M3U8_UNKOWN_MIME_TYPE, mimeTypeForM3U8Segments)) {
+			/* TODO : if mime-type is still unknown, don't try to add codec information since it would be wrong */
+			if (!strcmp(M3U8_UNKNOWN_MIME_TYPE, mimeTypeForM3U8Segments)) {
 				fprintf(fmpd, " mimeType=\"%s\"", mimeTypeForM3U8Segments);
+				GF_LOG(GF_LOG_WARNING, GF_LOG_DASH, ("[MPD] Unknown mime-type when converting from M3U8 HLS playlist, setting %s\n", mimeTypeForM3U8Segments));
 			} else {
 				fprintf(fmpd, " mimeType=\"%s\"", mimeTypeForM3U8Segments);
 			}
@@ -1539,7 +1554,7 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 
 			byte_range_media_file = NULL;
 			elt = gf_list_get(pe->element.playlist.elements, 0);
-			if (elt && (elt->byteRangeEnd || elt->byteRangeStart)) {
+			if (elt && (elt->byte_range_end || elt->byte_range_start)) {
 				byte_range_media_file = elt->url;
 				fprintf(fmpd, "    <BaseURL>%s</BaseURL>\n", byte_range_media_file);
 			} else if (sep) {
@@ -1547,14 +1562,14 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				fprintf(fmpd, "    <BaseURL>%s</BaseURL>\n", base_url);
 			}
 
-			fprintf(fmpd, "    <SegmentList duration=\"%d\">\n", pe->durationInfo);
-			update_interval = (count3 - 1) * pe->durationInfo * 1000;
-			for (k=0; k<count3; k++) {
+			fprintf(fmpd, "    <SegmentList duration=\"%d\">\n", pe->duration_info);
+			update_interval = (count_elements - 1) * pe->duration_info * 1000;
+			for (k=0; k<count_elements; k++) {
 				u32 cmp = 0;
 				char *src_url, *seg_url;
 				elt = gf_list_get(pe->element.playlist.elements, k);
 
-				/*remove protocol scheme and try to find the common part in baseURL and segment URL - this avoids copying the entire url*/
+				/* remove protocol scheme and try to find the common part in baseURL and segment URL - this avoids copying the entire url */
 				src_url = strstr(base_url, "://");
 				if (src_url) src_url += 3;
 				else src_url = base_url;
@@ -1566,8 +1581,9 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 				while (src_url[cmp] == seg_url[cmp]) cmp++;
 
 				if (byte_range_media_file) {
-					fprintf(fmpd, "     <SegmentURL mediaRange=\""LLU"-"LLU"\"", elt->byteRangeStart, elt->byteRangeEnd);
-					if (strcmp(elt->url, byte_range_media_file) )fprintf(fmpd, " media=\"%s\"", elt->url);
+					fprintf(fmpd, "     <SegmentURL mediaRange=\""LLU"-"LLU"\"", elt->byte_range_start, elt->byte_range_end);
+					if (strcmp(elt->url, byte_range_media_file))
+						fprintf(fmpd, " media=\"%s\"", elt->url);
 					fprintf(fmpd, "/>\n");
 				} else {
 					fprintf(fmpd, "     <SegmentURL media=\"%s\"/>\n", cmp ? (seg_url + cmp) : elt->url);
@@ -1590,8 +1606,10 @@ GF_Err gf_m3u8_to_mpd(const char *m3u8_file, const char *base_url,
 	fprintf(fmpd, "  </AdaptationSet>\n");
 	fprintf(fmpd, " </Period>\n");
 	fprintf(fmpd, "</MPD>");
+
 	fclose(fmpd);
-	variant_playlist_del(pl);
+	gf_m3u8_variant_playlist_del(pl);
+
 	return GF_OK;
 }
 
@@ -1835,7 +1853,7 @@ static u32 gf_mpd_print_common_representation(FILE *out, GF_MPD_CommonAttributes
 
 static void gf_mpd_print_representation(FILE *out, GF_MPD_Representation *rep)
 {
-	Bool can_close = 0;
+	Bool can_close = GF_FALSE;
 	fprintf(out, "   <Representation");
 	if (rep->id) fprintf(out, " id=\"%s\"", rep->id);
 	if (rep->bandwidth) fprintf(out, " bandwidth=\"%d\"", rep->bandwidth);
@@ -1844,7 +1862,7 @@ static void gf_mpd_print_representation(FILE *out, GF_MPD_Representation *rep)
 	if (rep->media_stream_structure_id) fprintf(out, " mediaStreamStructureId=\"%s\"", rep->media_stream_structure_id);
 
 
-	if (!gf_list_count(rep->base_URLs) && !rep->segment_base && !rep->segment_template && !rep->segment_list && !gf_list_count(rep->sub_representations) ) {
+	if (!gf_list_count(rep->base_URLs) && !rep->segment_base && !rep->segment_template && !rep->segment_list && !gf_list_count(rep->sub_representations)) {
 		can_close = 1;
 	}
 
@@ -1976,7 +1994,7 @@ static GF_Err gf_mpd_write(GF_MPD *mpd, FILE *out)
 	char *text;
 	GF_MPD_Period *period;
 
-	fprintf(out, "<?xml version=\"1.0\"?>\n<MPD xmlns=\"%s\" type=\"%s\"", mpd->xml_namespace, (mpd->type == GF_MPD_TYPE_STATIC) ? "static" : "dynamic" );
+	fprintf(out, "<?xml version=\"1.0\"?>\n<MPD xmlns=\"%s\" type=\"%s\"", mpd->xml_namespace, (mpd->type == GF_MPD_TYPE_STATIC) ? "static" : "dynamic");
 
 	if (mpd->ID)
 		fprintf(out, " ID=\"%s\"", mpd->ID);
@@ -2331,7 +2349,7 @@ GF_Err gf_mpd_resolve_url(GF_MPD *mpd, GF_MPD_Representation *rep, GF_MPD_Adapta
 		return GF_OK;
 	}
 	/*let's solve the template*/
-	solved_template = gf_malloc(sizeof(char)*(strlen(url_to_solve) + (rep->id ? strlen(rep->id) : 0) ) * 2 );
+	solved_template = gf_malloc(sizeof(char)*(strlen(url_to_solve) + (rep->id ? strlen(rep->id) : 0)) * 2);
 	solved_template[0] = 0;
 	strcpy(solved_template, url_to_solve);
 	first_sep = strchr(solved_template, '$');
